      PROGRAM DECOD
C
      IMPLICIT INTEGER*2 (I-N), REAL*4 (A-H,O-Z)
      LOGICAL ZAHL
      CHARACTER CSTRING*30
C 
      WRITE ( *,* ) 'Eingabestring mit Realzahl'
      READ ( *,'(A)' ) CSTRING
C
      RR = 111.
      CALL PARSV ( CSTRING,RR,ZAHL )
      WRITE ( 6,* ) ZAHL, RR
C
      END
C---------------------------------------------------------------------
      SUBROUTINE PARSV ( INPUT,PAR,ZAHL )
C---------------------------------------------------------------------
C     Lesen einer Realvariablen aus einem Characterstring
C---------------------------------------------------------------------
C     input  - Eingabefeld CHARACTER (variable Laenge), sollte Leerzeichen
C               enthalten
C     nc     - Anzahl Zeichen in INPUT
C     par    - Realparameter
C     zahl   - Logische Variable: .true, wenn eine Zahl in Input gefunden
C               wurde
C---------------------------------------------------------------------
C      3:29 PM  FRI.,  7  JUNE, 1985 , Volkhard Spiess , RUB/GUB   (1)
C---------------------------------------------------------------------
      IMPLICIT INTEGER*2 (I-N), REAL*4 (A-H,O-Z)
C
      LOGICAL ZAHL
C
      CHARACTER*(*) INPUT
      CHARACTER*1   KCHAR,KCHARA
      CHARACTER*9   FORM
C
      DATA FORM / '         ' /
C--Logische Variable 
      ZAHL = .FALSE.
C--
      NC = LEN ( INPUT )
C
      INUM  = 1
      IREAL = 0
      IDEZ  = 0
      IEX   = 0
      IBLANK= 1
C
C--Pruefen der Zeichen   INUM = 1 : nur numerische Zeichen ( 0-9,+,- )
C                        IREAL= 1 : zusaetzlich 'E' oder '.'
C                        IDEZ     : Position des Dez.punktes ( 0=keiner )
C                        IEX      : Position des Exp.zeichen ( 0=keins )
C
      KCHAR = CHAR ( 0 )
      NG = NC
C
      DO 30 J = 1,NC
C
        KCHARA= KCHAR
        KCHAR = INPUT(J:J)
C--Leerzeichen: weiter
        IF ( KCHAR.EQ.' ' ) GOTO 30
        NG     = J
        IBLANK = 0
C
C--numerisches Zeichen zwischen 0 und 9 gefunden
        IF ( LGE(KCHAR,'0') .AND. LLE(KCHAR,'9') ) GOTO 30
C--Vorzeichen gefunden
        IF ( KCHAR.EQ.'-' .OR.KCHAR.EQ.'+' ) THEN
          IF ( J     .EQ. 1  ) GOTO 30
          IF ( KCHARA.EQ.'E' ) GOTO 30
        ENDIF
C--Von den uebrig bleibenden Zeichen sind nur noch . und E erlaubt,
C  sonst wird inum=0 gesetzt
        IF ( KCHAR.NE.'.' .AND. KCHAR.NE.'E' ) GOTO 31
C
        IF ( INUM.EQ.1 ) THEN
          IF ( KCHAR.EQ.'.' .OR. (KCHAR.EQ.'E'.AND.J.GT.1) ) IREAL=1
        ENDIF
C
        IF ( IREAL.NE.1 ) GOTO 31
        IF ( KCHAR.EQ.'.' ) IDEZ = J
        IF ( KCHAR.EQ.'E' ) IEX  = J
        GOTO 30
C
31      CONTINUE
        INUM = 0
30    CONTINUE
C----------------------------
C--Keine numerische Variable?
      IF ( INUM.EQ.0 .OR. IBLANK.EQ.1 ) GOTO 90
C-------------------------------------
C--Formatdefinition und Lesen der Zahl
      FORM(1:1) = '('
      IFO       = 2
C--F/E-Format
      FORM(IFO:IFO) = 'F'
      IF ( IEX.NE.0 ) FORM(IFO:IFO) = 'E'
C--Dezimalstellen/Laenge des Exponenten
      NNK = 0
      IF ( IDEZ.GT.0 ) THEN
        IF ( IEX.EQ.0 ) THEN
          NNK = NG - IDEZ 
        ELSE
          NNK = IEX - IDEZ - 1
        ENDIF
      ENDIF
      WRITE ( FORM(IFO+1:),'(I2.2,A,I2.2,A)',ERR=90 ) NG,'.',NNK,')'
      IFO = IFO + 6
C--------------------------------------------------------
C--Decodieren des Eingabestrings mit dem erzeugten Format
CCC      WRITE ( 6,* ) FORM(:IFO)
      READ ( INPUT,FORM(1:IFO),ERR=90 ) RE
C--Zuweisung auf UP-Parameter, falls kein Fehler aufgetreten ist
      PAR  = RE
      ZAHL = .TRUE.
      RETURN
C--------------------------------------------------
C--Dieser Label wird nur im Fehlerfall angesprungen
90    CONTINUE
      ZAHL = .FALSE.
      RETURN
      END