      PROGRAM DIST
C
      IMPLICIT DOUBLE PRECISION (D)
      CHARACTER NAKFILN*18, EXCEL*120, MAC*120
C
C.....Daten lesen und Distanzen berechnen
C
      WRITE (6,'(/,A)') '$Filename: '
      READ  (5,'(A)') NAKFILN
      OPEN (33, FILE=NAKFILN, STATUS='OLD')
      OPEN (44, FILE=NAKFILN, STATUS='NEW')
      N = 0
      DRIST = 0.D00
C
 1000 CONTINUE
      READ (33,'(2(1X,I2.2,X,I2.2,X,I2.2),
     &  1X,F10.5,1X,F10.5,2F6.1,1X,2F6.2,1X,3(F6.0,1X))', END=1100) 
     &  ID2, IM2, IY2, IH2, MI2, IS2,
     &  DP1,DL1,SPEED,COURSE,SALZG,TEMPE,EDEPTH,PDEPTH,HDEPTH
C
C......0 bei Tiefen raus
C
      IF (PDEPTH .EQ. 0. .AND. HDEPTH .EQ. 0.) GOTO 1000
      IF (PDEPTH .EQ. 0.) PDEPTH = HDEPTH
      IF (HDEPTH .EQ. 0.) HDEPTH = PDEPTH
      N = N+1
      IF (N .EQ. 1) GOTO 1050
C
C......Distanz berechnen
C
      DPI=4.D00*DATAN (1.D00)
      DRADI=6366707.D00 
      DRHO=180.D00/DPI
C
C......gleiche Position
C
      IF ((ABS(DP2-DP1).LE.0.00001D0).AND.                              !NI0189
     &(ABS(DL2-DL1).LE.0.00001D0)) THEN                                 !NI0189
         DDI=0.0D0                                                      !NI0189
         DCO=0.0D0                                                      !NI0189
      ELSE                                                              !NI0189
         DLAM=DL2-DL1
         DIBO=DACOSD (DSIND(DP1)*DSIND(DP2)+DCOSD(DP1)*DCOSD(DP2)* 
     &   DCOSD(DLAM))
C
C......Distanz in Kilometer
C
         DRIST=((DRADI*DIBO)/DRHO)/1000.
      END IF
C
C......ThermoSalinograph - Salzgehalt korrigieren, Faktor fuer ANTVIII/3
C
 1050 CONTINUE
CCC      SALZG = 0.939 * SALZG + 6.314
C
C......Daten neu schreiben
C
      DP2 = DP1
      DL2 = DL1
      WRITE (44,'(2(1X,I2.2,A,I2.2,A,I2.2),
     &  1X,F10.5,1X,F10.5,2F6.1,1X,2F6.2,1X,3(F6.0,1X),F8.2)') 
     &  ID2,'-',IM2,'-',IY2,IH2,':',MI2,':',IS2,
     &  DP2,DL2,SPEED,COURSE,SALZG,TEMPE,EDEPTH,PDEPTH,HDEPTH,DRIST
      GOTO 1000
C
 1100 CONTINUE
      CLOSE (33, STATUS='DELETE')
      CLOSE (44)
C
C......fuer MAC umformen
C
      OPEN (13, FILE=NAKFILN, STATUS = 'OLD')
      OPEN (14, FILE=NAKFILN, CARRIAGECONTROL='LIST', STATUS = 'NEW')
 1199 CONTINUE

      EXCEL = ' '
      MAC   = ' '
  792 CONTINUE
      READ (13,'(A120)', END = 1198) EXCEL
C
C.....Leerzeichen durch TAB ersetzen
      ITAB = 1
      IMAC = 0
      LSTRING = NZEICH(EXCEL)
      DO I = 1, LSTRING
         IF (EXCEL(I:I) .EQ. ' ') THEN
            IF (ITAB .EQ. 0) THEN
               IMAC = IMAC + 1
               MAC(IMAC:IMAC) = '	'
               ITAB = 1
            END IF
         ELSE
            IMAC = IMAC + 1
            MAC (IMAC:IMAC) = EXCEL(I:I)
C
C.....Punkte durch Komma ersetzen
            IF (MAC(IMAC:IMAC) .EQ. '.') MAC(IMAC:IMAC) = ','
            ITAB = 0
         END IF
      END DO
      WRITE (14,'(A)') MAC(:IMAC)
      GOTO 1199
 1198 CONTINUE
      CLOSE (13,STATUS='DELETE')
      CLOSE (14)
      END
C==============================================================================
      INTEGER*2 FUNCTION NZEICH ( CH )
C     Anzahl Zeichen in Characterfeld (ohne Blanks am Ende)
C
      IMPLICIT INTEGER*2 (I-N), REAL*4 (A-H,O-Z)
      CHARACTER CH*(*), CC*1
C
      NZEICH = LEN ( CH )
      NZ     = NZEICH
      DO 10 J = NZ,1,-1
        CC = CH(J:J)
        IF ( CC.NE.' ') RETURN
        NZEICH = NZEICH - 1
        IF ( NZEICH.EQ.0 ) RETURN
10    CONTINUE
      END