      subroutine param
C.....Datenbankabfrage
C
C-----Deklarationen                            
      PARAMETER (NPRO=1600)  ! Anzahl Proben
      PARAMETER (NPAR=400)   ! Anzahl Parameter
      PARAMETER (NTIEF=25)   ! Anzahl Tiefenserien
      CHARACTER*30 FILNAM, jn*1, engl(npar)*20,
     *          PARA(NPAR)*40, KERN*6, KERN1*6, LLL*70, KKEN*4,
     *          cnstat*4, cgstat*1, KPTEXT(NTIEF)*50, cls*40, ff*12,
     *          cyes(20)*30
      INTEGER   NS, NV, KEN(NPAR), VAROUT(NPAR), KPT, COL(3,150),
     *          REST, KTEST(NPAR), KENZ, IRD(2000), SUMIRD, FARB(2),
     *          ANTI(NTIEF), ANZGR, yes(20)
      REAL      FELD(NPAR,NPRO), XIN(NPRO,2), XOUT(NPRO*10,2),
     *          TIEF(NTIEF,NPRO)
C 
      common /fe/ feld, tief, ken, anti, kptext
      common /pa/ para, engl
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
      WRITE (6,1001)
 1001 FORMAT (//,
     *12X,' ********************************************************'/
     *12X,' ************************ P A R A ***********************'/
     *12X,' ********************************************************'/
     *12X,' ********* Datenbank nach Parametern durchsuchen ********')
C
      write (6,'(//,a,12x,a)')'$','erste  Stationsnummer           > '
      read  (5,*) is1
      write (6,'(a,12x,a)') '$','letzte Stationsnummer           > '
      read  (5,*) isn
      write (6,'(a,12x,a)') '$','bestimmten Parameter suchen [N] > '
      read  (5,'(a)') jn
      call caps(jn)
      if (jn .eq. 'J') then
         call par(ipar)
         if (ipar .eq. 0) goto 12345
      end if
      open (12, file = 'para.txt', carriagecontrol='list',status='new')
      if (jn .eq. 'J') write (12,'(2a)') 'Parameter  ', para(ipar)
      write (6,'(/a)') ' vorhandene Kerne:'
C.....filenamen erzeugen
 1111 CONTINUE
      do ii = is1, isn
         write (cnstat, '(i4)') ii
  100    do j = 1, 9
            write (cgstat, '(i1)') j
            filnam = 'sys$user:[geologie]'//cnstat//'.'//cgstat//'sed'
            OPEN (99,
     *        FILE=FILNAM, STATUS='OLD', err=150, FORM='UNFORMATTED')
C..............................................................................
C.....Anzahl der Proben {ANTI(K)} und Probentiefen {TIEF(K,I)} einlesen
      DO K=1,NTIEF
         READ (99) ANTI(K), (TIEF(K,I), I=1,ANTI(K))
         IF (ANTI(K) .NE. 0) READ (99) KPTEXT(K)
      END DO
      READ (99) SUMIRD            
      READ (99) TOP, BOT, ANZGR              
C
C.....Sedimentparameter einlesen
  199 CONTINUE
      READ (99, END=177) KTIEF, KENZ, (FELD(KENZ,I), I=1,ANTI(KTIEF))
      KEN(KENZ) = KTIEF
      GOTO 199
  177 CONTINUE
      CLOSE (99)
C..............................................................................
C.....einzelnen Parameter suchen
      if (jn .eq. 'J') then
         if (ken(ipar) .ne. 0) then
            write (12,'(3a,3x,f10.2,3x,i5)') 
     *            cnstat, '-', cgstat, bot, anti(ken(ipar))
            write (6, '(x,a,3x,a,i5)')filnam,para(ipar),anti(ken(ipar))
         else
            write (6,'(x,a)') filnam
         end if
         goto 55
      else
         write (6,'(x,a)') filnam
      end if
C..............................................................................
C.....Tiefenserien + Parameter in Textfile schreiben
      write (12,'(/,x,3a,5x,f10.2)') cnstat, '-', cgstat, bot
      write (12,'(x,a)') '====================================='
      do i7 = 1, ntief
         if (anti(i7) .ne. 0) 
     *       write(12,'(2x,i2,2x,i4,x,a)') i7, anti(i7), kptext(i7)
      end do
      write (12,'(x,a)') '-------------------------------------'
C
C.....in Feld YES stehen die zu ueberpruefenden Parameter
      data yes / 2,7,9,13,14,16,17,19,20,23,24,27,32,35,50,97,
     *           123,127,133,140 /
      data cyes/'Wassergehalt','Waermeleitfaehigkeit','Scherfestigkeit',
     *'elektr. Widerstand','Leitfaehigkeit','Dichte',
     *'Schallgeschwindigkeit','Fragmentierung','Kohlenstoff',
     *'Opalgehalt','Schwefel','IRD','Sand/Silt/Ton','Korngroessen',
     *'Tonmineralogie','Radiolarien%','stab.Isotope/plankt.F.',
     *'stab.Isotope/benth.F.','Palaeomagnetik','Suszeptibilitaet'/
      do i20 = 1,20
         if (ken(yes(i20)) .ne. 0)
     *       write (12,'(x,i3,3x,a)') ken(yes(i20)), cyes(i20)
      end do
C..............................................................................
C.....Felder leeren
  55  continue
      do ileer = 1, 400
         ken(ileer) = 0
      end do
C..............................................................................
  150    end do
 1234 end do
      write (6,'(/,x,a)') 'Informationen stehen in File PARA.TXT !'
      CALL RET
      close (12)
12345 END