      PROGRAM COUNT
	INCLUDE '($IODEF)'
C
C     allgemeines Zaehlprogramm 
C                                                        H. GROBE, 1987
C----------------------------------------------------------------------
C
C     --Variablen--
      CHARACTER KEY(93)*1, NAME(93)*60, YN*1, FILEN*20, Z*1,
     *          FN*11, EXT*3, ISAMP*12
        CHARACTER IDEVNM*2, FINDEX*17, CZ*3, FORM*20
C
      INTEGER ANZAHL, KORNZA, RAW(100)
	INTEGER*4 SYS$ASSIGN,SYS$QIOW,IEFN,ISTAT
	INTEGER*2 ICHAN
	BYTE IBUF(2)
      REAL DAT(100)
C
	DATA IDEVNM / 'TT' /,IEFNM / 17 /
C
C----------------------------------------------------------------
	ISTAT=SYS$ASSIGN( IDEVNM,ICHAN,,)
	IF( .NOT.ISTAT )  CALL LIB$STOP(ISTAT)
C
    1 CONTINUE                            
      TYPE 100
  100 FORMAT
     *(X,'**************************************************
     *****************************'/
     *X,'**************************************************
     *****************************'/
     *X,'*******',64X,'*******'/
     *X,'*****',68X,'*****'/
     *X,'***       ALFRED - WEGENER - INSTITUT for POLAR and 
     * MARINE RESEARCH       ***'/
     *X,'*',76X,'*'/
     *X,'***                              BREMERHAVEN      
     *                         ***'/
     *X,'*****',68X,'*****'/
     *X,'*******',64X,'*******'/
     *X,'**************************************************
     *****************************'/
     *X,'**************************************************
     *****************************'/
     *X,'*******',64X,'*******'/
     *X,'*****',68X,'*****'/
     *X,'***',72X,'***'/
     *X,'*                                 C O U N T                
     *                  *'/
     *X,'*',76X,'*'/
     *X,'*                         Program to count particles       
     *                  *'/
     *X,'***',72X,'***'/
     *X,'******',66X,'******'/
     *X,'*********',60X,'*********'/)
C
      WRITE (6, '(//,A)') '$Create or edit key-file ?   [N] '
      READ (5, '(A)') YN
      IF (YN .EQ. 'Y' .OR. YN .EQ. 'y') THEN
         CALL SKEY
         GOTO 1
      END IF
      WRITE (6, '(//,A)') '$Input name of key-file :           '
      READ (5, '(A11)') FN
      WRITE (6, '(/,A)')  '$Show names of keys ?        [N] '
      READ (6,'(A)') YN
      OPEN (12, FILE=FN, STATUS='OLD')
      IF (YN .EQ. 'Y' .OR. YN .EQ. 'y') THEN
            WRITE (6, '(//,X,2A,/)') 'Key-file is ==>   ', FN
      END IF
      DO I =1,93
         READ (12, '(X,A,3X,A60)') KEY(I), NAME(I)
         IF (YN .EQ. 'Y' .OR. YN .EQ. 'y') THEN
            WRITE (6, '(X,A,3X,A60)') KEY(I), NAME(I)
         END IF
      END DO
      CLOSE (12)
C
      WRITE (6,'(/,A)') '$Name of raw data file :   '
      READ (5, '(A)') FILEN
      IF (FILEN .EQ. ' ') GOTO 1234
      OPEN (11, FILE=FILEN, STATUS='NEW')
C
 876  CONTINUE
      WRITE (6, '(/,A)') '$Particles/sample to count :   '
      READ  (5,*) KORNZA
C
 999  CONTINUE
      WRITE (6, '(/,A)') '$Sample-Number :   '
      READ  (5,'(A)') ISAMP
      DO J=1,100
         RAW(J) = 0
      END DO
      ANZAHL = 0
C------------------------------------------------------------------
C     Zaehlschleife
C------------------------------------------------------------------
      TYPE 34
   34 FORMAT (//,X,'##########################################'/
     *        X,'=========================================='/
     *        X,'------------------------------------------'/
     *        X,'         ***  START COUNTING  ***         '/
     *        X,'------------------------------------------'/
     *        X,'========= type ? to stop counting ========'/
     *        X,'##########################################',//)
C-----Taste in Variable Z einlesen---------------------------------
  200 CONTINUE
     	ISTAT=SYS$QIOW(%VAL(IEFN),%VAL(ICHAN),
     &		%VAL(IO$_TTYREADALL.OR.IO$M_NOECHO),,,,
     &		IBUF,%VAL(1),,,, )
	IBUF(1)=IBUF(1).AND."177	
	DECODE(1,221,IBUF) Z
  221	FORMAT( A1 )
C------------------------------------------------------------------
      DO 345 K=1,93
         IF (Z .EQ. '?') GOTO 300
         IF (Z .EQ. KEY(K)) THEN
            IF (NAME(K) .EQ. ' ') THEN
               WRITE (6,'(/,A)') 
     *          ' ******************************************'
               WRITE (6,'(A)')   
     *          ' ************  Key not used ! *************'
               WRITE (6,'(A)') 
     *          ' ******************************************'
               CALL SBELL
               GOTO 200
            END IF
            RAW(K) = RAW(K)+1
            ANZAHL = ANZAHL + 1
            WRITE (6, '(X,A,3X,I4,3X,A60,I4)')
     *            KEY(K), RAW(K), NAME(K), ANZAHL
            IF (ANZAHL .EQ. KORNZA) GOTO 300
            GOTO 200
         END IF
  345 CONTINUE
C------------------------------------------------------------------
  300 CONTINUE
      CALL SBELL
      TYPE 36
   36 FORMAT (//,X,'##########################################'/
     *        X,'=========================================='/
     *        X,'------------------------------------------'/
     *        X,'         ***  STOP  COUNTING  ***         '/
     *        X,'------------------------------------------'/
     *        X,'=========================================='/
     *        X,'##########################################',/)
      CALL SBELL
C----------------------------------------------------------------
C     Daten speichern
C----------------------------------------------------------------
      ISUM = 0
      DO 765 L=1,93
         DAT(L) = 0.0
         IF (NAME(L) .NE. ' ') ISUM = ISUM + RAW(L)
  765 CONTINUE
      IF (ISUM .EQ. 0) GOTO 1234
      NZ = 0
      DO 767 L=1,93
         IF (NAME(L) .NE. ' ') THEN
            NZ = NZ+1
            DAT(NZ) =  100./ISUM*RAW(L)
         END IF
  767 CONTINUE
      WRITE (CZ,'(I3)') NZ
      FORM = '(X,A12,'//CZ//'F7.2)'
      WRITE (11,FORM) ISAMP, (DAT(L), L = 1,NZ)
      GOTO 999
 1234 CONTINUE
      CLOSE (11)
      END
C===============================================================================
      SUBROUTINE SKEY
C
C     INPUT OF KEY NAMES
C     OUTPUTFILE WILL BE USED IN PRG. "COUNT"
C
C-----VARIABLEN--
      CHARACTER N*60, NAME(93)*60, KY(93)*1, YN*1, EXT*3, FN*11
      DATA KY / '`','1','2','3','4','5','6','7','8','9','0','-','=',
     *           'q','w','e','r','t','y','u','i','o','p','[',']',
     *           'a','s','d','f','g','h','j','k','l',';','''','\',
     *           '<','z','x','c','v','b','n','m',',','.','/',
     *           '~','!','@','#','$','%','^','&','*','(',')','_','+',
     *           'Q','W','E','R','T','Y','U','I','O','P','{','}',
     *           'A','S','D','F','G','H','J','K','L',':','"','|',
     *           '>','Z','X','C','V','B','N','M' /
C
      TYPE 111
  111 FORMAT  (15X,'************************************************'/
     *         15X,'************************************************'/
     *         15X,'**                                            **'/
     *         15X,'**                                            **'/
     *         15X,'**             Subroutine   K E Y             **'/
     *         15X,'**            ********************            **'/
     *         15X,'**                                            **'/
     *         15X,'**             Input of key names             **'/
     *         15x,'**                                            **'/
     *         15x,'**                                            **'/
     *         15X,'************************************************'/
     *         15X,'************************************************')
C
      WRITE (6,'(//,A)') '$Modify existing key-file ?  [N]  '
      READ  (5,'(A)') YN
      IF (YN .EQ. 'Y' .OR. YN .EQ. 'y') THEN
C
C-----Read old key-file
C
      WRITE (6,'(/,A)') '$Input name of old key-file :  '
      READ (5, '(A)') FN
      OPEN (55, FILE=FN, STATUS='OLD')
      K = 1
   33 CONTINUE
      READ (55, '(X,A,3X,A60)',END=555) KY(K), NAME(K)
      K = K+1
      GOTO 33
  555 CLOSE (55)
C
      WRITE (6,'(//,X,A)') 'Input new name of particle concerning
     * to given key (max. 60 Characters, 93 Keys)'
      WRITE (6,'(X,A,/)') 'or press <RETURN> to keep the old name:'
      WRITE (6,'(X,A,/)') '*** type EX to Exit ***'
      WRITE (6,'(X,A,3X,A)') 'KEY', 'NAME'
      WRITE (6,'(A)')
     * '--------------------------------------------------------------'
      DO 44 J=1,93
         WRITE (6,'(X,3A)') KY(J), '     ', NAME(J)
         WRITE (6,'(A,5X,A)') '$', ' '
         READ (5,'(A)') N
         IF (N .EQ. 'EX') THEN
            GOTO 78
         ELSE IF (N .NE. ' ') THEN
            NAME(J) = N
         END IF
   44 CONTINUE
      GOTO 78
      END IF
C
  567 CONTINUE
      WRITE (6,'(/,A)')
     * '$Input name of new key-File  :  '
      READ (5, '(A)') FN
      WRITE (6,'(//,X,A47,/)') 'Input name of particle concerning
     * to given key (max. 60 Characters)'
      DO 444 J=1,93
         WRITE (6,'(3A)') '$', KY(J),'  =>  '
         READ (5,'(A)') NAME (J)
  444 CONTINUE
C
C-----save key names in key-file
C
   78 CONTINUE
      OPEN (11, FILE=FN, STATUS='NEW')
      DO 222 I=1,93
         WRITE (11,'(X,A,3X,A60)') KY(I), NAME(I)
  222 CONTINUE
      CLOSE (11)                                                        
      WRITE (6,'(//,X,A,A)') 
     *       'Key names have been saved in file ', FN
      WRITE (6,'(X,A)') 'which will be used by the main program  COUNT'
      END
C*******************************************************************************
C*******************************************************************************
      SUBROUTINE SBELL
C
      CHARACTER*1 E,A
      E=CHAR(27)
      DO 10 I=1,3
      A=CHAR(7)
      WRITE (6,100) E,'[0m',A
  100 FORMAT (1X,A1,A3,A1)
      DO 20 J=1,11000
      X = (X + 2*5/123.654)*0.0009
   20 CONTINUE
   10 CONTINUE
      END