      PROGRAM RACSPH 
C******************************************************************************
C                                                                             *
C     Die Routine berechnet die Grosskreisentfernung zwischen zwei Positionen *
C     und den Anfangskurs                                                     *
C                                                                             *
C     Subr.:                                                                  *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar und Meeresforschung           *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 18.01.1989
C******************************************************************************
C
      IMPLICIT DOUBLE PRECISION (A-H), DOUBLE PRECISION (O-Z)
C 
      PI=4.D00*DATAN (1.D00)
      RADIUS=6366707.D00 
      RHO=180.D00/PI
C
      WRITE (6,'($1X,A)') 'PHIA > '
      READ  (5,*) DP1
      WRITE (6,'($1X,A)') 'LAMA > '
      READ  (5,*) DL1
      WRITE (6,'($1X,A)') 'PHIE > '
      READ  (5,*) DP2
      WRITE (6,'($1X,A)') 'LAME > '
      READ  (5,*) DL2
      WRITE (6,*)
C
C......gleiche Position
C
      IF ((ABS(DP2-DP1).LE.0.00001D0).AND.                              !NI0189
     &(ABS(DL2-DL1).LE.0.00001D0)) THEN                                 !NI0189
         DDI=0.0D0                                                      !NI0189
         DCO=0.0D0                                                      !NI0189
      ELSE                                                              !NI0189
         DLAM=DL2-DL1
         DIBO=DACOSD (DSIND(DP1)*DSIND(DP2)+DCOSD(DP1)*DCOSD(DP2)* 
     &   DCOSD(DLAM))
C
C......Distanz in Kilometer
C
         RIST=((RADIUS*DIBO)/RHO)/1000.
         WRITE (6,'(A,F10.3)') ' DISTANZ (km)  = ', RIST
C
C......Distanz in Meilen
C
         DDI=60.D00*DIBO
         WRITE (6,'(/A,F10.3)') ' DISTANZ (sm)  = ', DDI
C
         SINCOU=(DSIND(DLAM)*DCOSD(DP2))/DSIND(DIBO)
         IF (SINCOU.GT.1.D00) THEN
            SINCOU=1.D00
         ELSE IF (SINCOU.LT.-1.D00) THEN
            SINCOU=-1.D00
         END IF
         DCO=DASIND(SINCOU)
         IF (DP1.GT.DP2) THEN
            DCO=180.D00-DCO
         END IF
         IF (DCO.LT.0.D00) THEN
            DCO=DCO+360.D00
         END IF
      END IF                                                            !NI0189
      WRITE (6,'(/A,F7.0)') ' AZIMUT (grad) = ', DCO
C 
      END