      PROGRAM SEDAN
C                                                         Hannes Grobe * 1987ff
C______________________________________________________________________________
C
C-----Deklarationen                            
      PARAMETER (NPRO=1600)             ! Anzahl Proben
      PARAMETER (NPAR=400)              ! Anzahl Parameter
      PARAMETER (NTIEF=25)              ! Anzahl Tiefenserien
C
      CHARACTER*1 M, M1, M2, M3, M4, M2A, M2B, M2C, M2D, POL, BERE,
     *          JSN, CK, JN, JJN, JNN, TP, XYZ, CDUM*3, IC*3
      CHARACTER*35 FILOUT, FOUT, FIRD, FILNAM, DIFFDIR*40,
     *          PARA(NPAR)*40, KERN*6, KERN1*6, LLL*70, KKEN*3,
     *          FMT*45, FMT1*45, NW*10, CVAR*3, INCHAR*1, CRES*3, AT*6,
     *          FSEDI*30, SSILT(5)*17, GFRAK(5)*17, CIN*5, CLS*10,
     *          KPTEXT(NTIEF)*50, ZITAT*20, ZI*19,
     *          ENGL(NPAR)*20, TEXT*23, JN4*4, EXCEL*80, KR*9, COUT*5,
     *          TKTEXT(NTIEF)*25, EXCELH*2000, FILI*35, TAG*9, ZEIT*8,
     *          DCHAR*78, FILIN*50, MAC*2000, CSTRING*30
      CHARACTER*2 PHIT(11), PROZ(7), PHI*3, WORT(19)*4, KN*7, WW*17
C
      INTEGER   NS, NV, KEN(NPAR), VAROUT(NPAR), KPT,
     *          REST, KTEST(NPAR), KENZ, IRD(2000), SUMIRD,
     *          ANTI(NTIEF), ANZGR, COL(3,150),
     *          PF(50), T, F1, F2, F3, F4, MMFLAG
C
      REAL      FELD(NPAR,NPRO), XIN(NPRO,2), XOUT(NPRO*10,2), PT,
     *          TNEW, PINTE, GSF(6), FORM, SEDI(51),
     *          TIEF(NTIEF,NPRO), 
     *          XX(NPAR), YY(NPAR), ZZ(NPAR), XA(4000), YA(4000),
     *          XBAR(2000), YBAR(2000),
     *     SPX(100), SPY(100), Y2(200), PROD(7), F(7), DATEN(15),
     *     GSUMX(101), GSUMY(101), SUMX(51), SUMY(51), MWERT(100),
     *     MEAN, SKEW, KURT, SORT, SCHER(3)
C
      LOGICAL   ZAHL
C______________________________________________________________________________
C
      DATA PROD / 5., 16., 25., 50., 75., 84., 95. /
      DATA WORT / 'GRAV','SAND','SILT','CLAY',
     *            'MEAN','SKEW','KURT','SORT',
     *            'ME/S','SK/S','KU/S','SO/S',
     *  'PC 5','PC16','PC25','PC50','PC75','PC84','PC95' /
      DATA  GFRAK /  '0  (2000-1000 mm)', '1  (1000-500 mm)',
     *    '2  (500-250 mm)', '3  (250-125 mm)', '4  (125-63 mm)' /
      DATA  SSILT /  '%Wert bei 32 um', '%Wert bei 16 um',
     *    '%Wert bei 8 um', '%Wert bei 4 um', '%Wert bei 2 um' /
      DATA  TKTEXT / '1  Sedimentologie', '2  Paleomagnetik',
     * '3  Mikropaleontologie', '4  Geochemie', '5  Scherfestigkeit',
     * '6  Waermeleitfaehigkeit', '7  Schallgeschwindigkeit', 
     * '8  Suszeptibilitaet', '9  ice rafted debris', 
     * '10 spez. Widerstand', '11 frei', '12 frei', '13 frei', 
     * '14 frei', '15 frei', '16 frei', '17 frei', 
     * '18 frei', '19 frei', '20 frei',
     * '21 frei', '22 frei', '23 frei', 
     * '24 stratigr. Fixpunkte', '25 smear slides' /
C______________________________________________________________________________
C
      COMMON / FE / FELD, TIEF, KPT, KEN, ANTI, KPTEXT, JSN
      COMMON / PA / PARA, ENGL, COL, KERN
      COMMON / LU / LUW, IP1, IP2
      COMMON / MM / MMFLAG
C______________________________________________________________________________
C
      LLL = '----------------------------------------------------
     *----------------------------'
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
CCC      WRITE (6,'(///////////,36X,A)') 'GLUECKAUF'
C______________________________________________________________________________
C
C.....sedimentologische Parameterbezeichnungen lesen
      OPEN (88, FILE='sys$user:[grobe]PARA.SEDAN', STATUS='OLD')
      DO I = 1, NPAR
         IF (I .GT. 150) THEN
            READ (88, '(A40,A20)') PARA(I), ENGL(I)
         ELSE
            READ (88, '(A40,A20,X,3(I3,2X))') 
     *               PARA(I), ENGL(I), COL(1,I), COL(2,I), COL(3,I)
         END IF
      END DO
      CLOSE (88)
C______________________________________________________________________________
C
 1111 CONTINUE
      TYPE *, CLS
      WRITE (6,1001)
 1001 FORMAT (//,
     *12X,' ********************************************************'/
     *12X,' *************** ALFRED-WEGENER-INSTITUT ****************'/
     *12X,' *********** fuer POLAR- und MEERESFORSCHUNG ************'/
     *12X,' ********************************************************'/
     *12X,' ********                                        ********'/
     *12X,' ********  SSSSS  EEEEE  DDDD      A     NN   N  ********'/
     *12X,' ********  S      E      D   D    A A    N N  N  ********'/
     *12X,' ********  SSSSS  EEEE   D   D   AAAAA   N  N N  ********'/
     *12X,' ********      S  E      D   D  AA   AA  N   NN  ********'/
     *12X,' ********  SSSSS  EEEEE  DDDD  AA     AA N    N  ********'/
     *12X,' ********                                        ********'/
     *12X,' ********************************************************'/
     *12X,' ******************************************** HG ********'/
     *12X,' ********************************************************'/
     *12X,' ************** KERN * GRAF * KORP * PARA ***************')
      WRITE (6, '(/,A,12X,A)') '$', '===>> '
C
C.....Unterprogramme abfragen
      READ  (5, '(A)', ERR=1111) KERN
      CALL CAPS(KERN)
      IF (KERN .EQ. 'KORP') THEN
         CALL KORP
         GOTO 4321
      ELSE IF (KERN .EQ. 'GRAF') THEN
         CALL GRAF
         GOTO 4321
      ELSE IF (KERN .EQ. 'PARA') THEN
         CALL PARAM
         GOTO 4321
      ELSE IF (KERN .EQ. 'KERN') THEN
         WRITE (6, '(A,12X,A)') '$', 'Kern-Nr.>> '
         READ  (5, '(A)', ERR=1111) KERN
      END IF
C
C.....externen Datensatz oeffnen
      IF (KERN(1:1) .EQ. '0') KKEN = 'ODP'
      IF (KERN(1:1) .NE. '0') KKEN = ' PS'
      FILNAM = 'SYS$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'SED'
      FILIN =  ' '
      OPEN (99, FILE=FILNAM, STATUS='OLD', FORM='UNFORMATTED', ERR=119)
      OPEN (77, FILE=FILNAM, STATUS='NEW', ERR=167, FORM='UNFORMATTED')
      GOTO 168
  167 WRITE(6,'(/,20X,A/)')' kein Privileg fuer Datenspeicherung !'
  168 CLOSE (77, STATUS='DELETE')
C
C.....Anzahl der Tiefen {ANTI(K)} und Probentiefen {TIEF(K,I)} lesen
      DO K=1,NTIEF
         READ (99) ANTI(K), (TIEF(K,I), I=1,ANTI(K))
         IF (ANTI(K) .NE. 0) READ (99) KPTEXT(K)
      END DO
C
C.....Kernanfang, -ende, Sonderkennungen lesen
      READ (99) SUMIRD            
      READ (99) TOP, BOT, ANZGR
C    
C.....Sedimentparameter lesen
  199 CONTINUE
      READ (99, END=177) KTIEF, KENZ, (FELD(KENZ,I), I=1,ANTI(KTIEF))
      KEN(KENZ) = KTIEF
      GOTO 199
  177 CONTINUE
      CLOSE (99)
      GOTO 1000
C..............................................................................
  119 CONTINUE
      WRITE (6,'(/,A)')
     * ' Zu diesem Kern existiert kein Datensatz !'
      WRITE (6,'(/,A)') '$Neuen Datensatz anlegen ?   [J] '
      READ  (5,'(A)', ERR=119) JSN
      CALL CAPS (JSN)
      IF (JSN .EQ. 'N') GOTO 4321
      JSN = 'J'
      GOTO 200       
C******************************************************************************
C                                M A I N
C******************************************************************************
 1000 CONTINUE
      TYPE *, CLS
      WRITE (6,1002)
 1002 FORMAT (/,
     *14X,'                H A U P T M E N U E'/
     *14X,'               *=========*=========*'//
     *14X,' Tiefenserien listen .............................<0>'/
     *14X,' Parameter listen ................................<1>'//
     *14X,' Tiefenserien/Zeit ...............................<2>'/
     *14X,' Sedimentparameter ...............................<3>'/
     *14X,' frei ............................................<4>'//
     *14X,' Grafik ..........................................<5>'/
     *14X,' Auswertung ......................................<6>'//
     *14X,' formatierten Datensatz anlegen ..................<7>'/
     *14X,' Kennungen listen ................................<?>'//
     *14X,' SPEICHERN + EXIT ...........................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ  (5, '(A)', ERR=1000) M
      IF (M .EQ. ' ') GOTO 1234
      IF (M .EQ. '0') GOTO 100
      IF (M .EQ. '1') GOTO 150
      IF (M .EQ. '2') GOTO 200
      IF (M .EQ. '3') GOTO 300
CCC      IF (M .EQ. '4') GOTO 400
      IF (M .EQ. '5') GOTO 660
      IF (M .EQ. '6') GOTO 600
      IF (M .EQ. '7') GOTO 700
      IF (M .EQ. '?') GOTO 399
      WRITE (6,'(/,A,/)') ' *** Falsche Eingabe ! ***'
      GOTO 1000
C----------------------------------------------------------------------------
C-----Probenserien listen
  100 CONTINUE
      TYPE *, CLS
      WRITE (6, '(/,A)') ' *** PROBENSERIEN ***'
      WRITE (6, '(/,X,2A,2X,A)')  'K E R N    ', KKEN, KERN
      WRITE (6, '(/,X,A,F8.2,A)') 'Kernobergrenze   -> ', TOP, ' m'
      WRITE (6, '(  X,A,F8.2,A)') 'Kernuntergrenze  -> ', BOT, ' m'
      WRITE (6, '(/,X,A)') 'Tiefen-  |  Anzahl  |'
      WRITE (6, '(X,A)')   'kennung  |  Proben  |  Kommentar'
      WRITE (6, '(X,A)') LLL
      DO I=1,NTIEF
         IF (ANTI(I) .NE. 0) WRITE (6, 
     *'(4X,I4,2X,A,4X,I4,2X,A,2X,A50)') I, '|', ANTI(I), '|', KPTEXT(I)
      END DO
      NV = 0
      DO I = 1, NPAR                           ! Anzahl der Parameter bestimmen
         IF (KEN(I) .NE. 0) NV = NV+1
      END DO
      IF (NV .EQ. 0) THEN
         WRITE(6,'(/,X,A,I4)') ' keine Parameter gespeichert !'
      ELSE
         WRITE(6,'(X,A,I4)') 'Anzahl der gespeicherten Parameter: ', NV
      END IF
      CALL RET
      GOTO 1000
C----------------------------------------------------------------------------
C-----Parameter listen
  150 CONTINUE
      TYPE *, CLS
      WRITE (6, '(/,A)') ' *** GESPEICHERTE PARAMETER ***'
      WRITE (6, '(/,X,2A,2X,A)')  'K E R N    ', KKEN, KERN
      WRITE (6, '(/,X,A,F8.2,A)') 'Kernobergrenze   -> ', TOP, ' m'
      WRITE (6, '(  X,A,F8.2,A)') 'Kernuntergrenze  -> ', BOT, ' m'
      NV = 0
      DO I = 1, NPAR                           ! Anzahl der Parameter bestimmen
         IF (KEN(I) .NE. 0) NV = NV+1
      END DO
      IF (NV .EQ. 0) THEN
         WRITE(6,'(/,X,A,I4)') ' keine Parameter gespeichert !'
         CALL RET
         GOTO 1000
      ELSE
         WRITE(6,'(X,A,I4)') 'Anzahl der gespeicherten Parameter: ', NV
      END IF
      WRITE (6, '(/,X,A)')  'Tiefen-  |  Param.-  |'
      WRITE (6, '(X,A)')    'kennung  |  kennung  |  Parameter'
      WRITE (6, '(X,A)') LLL
      DO I = 1, NPAR
         IF (KEN(I) .NE. 0) 
     *      WRITE (6, '(4X,I4,2X,A,5X,I4,2X,A,2X,A40)')
     *                  KEN(I), '|', I, '|', PARA(I)
      END DO
      CALL RET
      GOTO 1000
C------------------------------------------------------------------------------
C-----neuen Datensatz anlegen
 2001 CALL MIST
  200 CONTINUE
      TYPE *, CLS
  202 WRITE (6,201)
  201 FORMAT (//,
     *14X,'                 Menue TIEFEN/ZEIT'/
     *14X,'                 ================='//
     *14X,' eingeben ........................................<1>'/
     *14X,' berechnen .......................................<2>'/
     *14X,' lesen ...........................................<3>'//
     *14X,' listen ..........................................<4>'/
     *14X,' einfuegen .......................................<5>'/
     *14X,' loeschen ........................................<6>'//
     *14X,' Kernanfang/-ende aendern ........................<7>'/
     *14X,' Kommentar aendern ...............................<8>'//
     *14X,' MAC-Daten lesen .................................<A>'/
     *14X,' SUSZI-Daten lesen ...............................<B>'/
     *14X,' Vp-Daten lesen ..................................<C>'/
     *14X,' PALMAG-Daten lesen ..............................<D>'//
     *14X,' HAUPTMENUE .................................<Return>'/)
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5,'(A)', ERR=200) M1 
      CALL CAPS(M1)
      IF (M1 .EQ. ' ') GOTO 1000
      IF (M1 .EQ. '4') GOTO 240
      IF (M1 .EQ. '5') GOTO 250
      IF (M1 .EQ. '6') GOTO 260
      IF (M1 .EQ. '7') GOTO 270
      IF (M1 .EQ. '8') GOTO 280
      IF (M1 .EQ. 'B' .OR. M1 .EQ. 'C') GOTO 207
C
C.....neuen SEDAN-Datensatz anlegen
  205 CONTINUE
      IF (JSN .EQ. 'J') THEN                           
         WRITE (6, '(/,A,F8.2)')' Kernanfang (m): alter Wert -> ', TOP
         WRITE (6, '(A)')       '$                neuer Wert ->  '
         READ  (5,*, ERR=205) TOP
         WRITE (6, '(/,A,F8.2)')' Kernende   (m): alter Wert -> ', BOT
         WRITE (6, '(A)')       '$                neuer Wert ->  '
         READ  (5,*, ERR=205) BOT
         WRITE (6, '(/,A)') '$Kennung der Probenserie > '
         READ (5, '(I4)', ERR=205) KPT
         WRITE (6,'(/,2A)') ' Kommentar : ', KPTEXT(KPT)
         WRITE (6,'(A)')     
     *      ' ___________________________________________________'
         READ  (5,'(A)', ERR=205) KPTEXT(KPT)
         JSN = 'Q'
         GOTO 207
      END IF
C
C.....neue Tiefenserie anlegen
      WRITE (6, '(/,A)') ' Vorhandene Probenserien : '
      WRITE (6, '(  A)') ' ------------------------- '
      DO I = 1,NTIEF
         IF (ANTI(I) .NE. 0 ) THEN
            WRITE (6,'(X,I2,2X,A)') I, KPTEXT(I)
         END IF
      END DO
  206 WRITE (6, '(/,A)') '$Kennung der neuen Serie > '
      READ (5, '(I4)', ERR=206) KPT
      IF (ANTI(KPT) .NE. 0) THEN
         WRITE (6,'(A)') 
     *   ' Serie existiert bereits ! - ueberschreiben ? [N] '
         READ (5,'(A)') JN
         CALL CAPS (JN)
         IF (JN .NE. 'J') GOTO 200
         ANTI(KPT) = 0
         GOTO 207
      END IF
      WRITE (6,'(/,2A)') ' Kommentar : ', KPTEXT(KPT)
      WRITE (6,'(A)')     
     *      ' ___________________________________________________'
      READ  (5,'(A)', ERR=206) KPTEXT(KPT)
  207 CONTINUE
C______________________________________________________________________________
C.....MAC-Datensatz lesen
      IF (M1 .EQ. 'A') THEN
         WRITE (6,'(/,A)') ' MAC-Datensatz lesen'
         WRITE (6,'(A)')   ' *******************'
         WRITE (6,'(/,A)') '$Filename  [GEO:1.DAT] > '
         READ  (5,'(A)') FILIN
         IF (FILIN .EQ. ' ') FILIN = 'ATK$USER:[GEOLOGIE]1.DAT'
         WRITE (6,'(/,A)')'$Werte in <CM> oder <M> gespeichert ?  [M] '
         READ  (5,'(1A)') JN
         CALL CAPS(JN)
C
C.....Komma durch Punkte ersetzen
         OPEN  (23, FILE=FILIN, RECL=8000, STATUS='OLD')
         OPEN  (24, FILE=FILIN, RECL=8000, STATUS='NEW')
         MAC = ' '
  204    CONTINUE
         READ (23,'(A)', END = 203) MAC
         LSTRING = NZEICH(MAC)
         DO I = 1, LSTRING
            IF (MAC(I:I) .EQ. ',') MAC(I:I) = '.'
         END DO
         WRITE (24,'(A)') MAC(:I)
         GOTO 204
C
  203    CONTINUE
         CLOSE (23)
         REWIND (24)
C
C.....lesen
         READ  (24, *) IKEN, (VAROUT(I), I=1,IKEN)
         N = 1
  209    CONTINUE
         READ (24, *, END=208)
     *        TIEF(KPT,N), (FELD(VAROUT(I),N), I=1,IKEN)  
         IF (JN .EQ. 'C')  TIEF(KPT,N) = TIEF(KPT,N)/100.
         N = N+1
         GOTO 209
C
  208    CLOSE (24, STATUS='DELETE')
         ANTI(KPT) = N-1
         DO I = 1, IKEN
            KEN(VAROUT(I)) = KPT
         END DO
         WRITE (6,'(/,A,I4)') ' Anzahl der gelesenen Werte: ',ANTI(KPT)
         CALL RET
         GOTO 200
      END IF
C______________________________________________________________________________
C.....SUSZI-Daten lesen
      IF (M1 .EQ. 'B') THEN
         WRITE (6,'(/,A)') ' SUSZI-Datensatz lesen'
         WRITE (6,'(A/)')   ' *********************'
         KPT = 8
         ANTI(KPT) = 0
         NT = 0
         KPTEXT(KPT) = 'SUSZEPTIBILITAET'
CCC        FILIN='ATK$USER:[GEOLOGIE]'//KERN(1:4)//'-'//KERN(6:6)//'SU.DAT'
         FILIN='PS'//KERN(1:4)//'C'//KERN(6:6)//'.SUS'
         OPEN  (23, FILE=FILIN, STATUS='OLD')
         OPEN  (24, FILE=FILIN, STATUS='NEW')
C
C........Sonderzeichen und Komma raus
         I = 0
         MAC = ' '
         EXCELH = ' '
  214    CONTINUE
         READ (23,'(A)', END = 217) MAC
         IF (I .NE. 0) WRITE (24,'(A)') EXCELH(:I-1)
         LSTRING = NZEICH(MAC)
         DO I = 1, LSTRING-1
            IF (MAC(I:I) .EQ. ',') MAC(I:I) = '.'
            IF (I .GT. 1) EXCELH (I-1:I-1) = MAC (I:I)
         END DO
         GOTO 214
C
  217    CONTINUE
         CLOSE (23)
         REWIND (24)
  290    READ  (24, *, END=292, ERR=239) 
     *         TIEF(KPT,ANTI(KPT)+1), FELD(140,ANTI(KPT)+1)
C
C........negative Tiefen und Null abfangen
         IF (TIEF(KPT,ANTI(KPT)+1) .LE. 0.) THEN
            ANTI(KPT) = 0
            GOTO 290
         END IF
C........negative Suszi-Werte abfangen
         IF (FELD(140,ANTI(KPT)+1) .LT. 0.) FELD(140,ANTI(KPT)+1) = 0.
C........falls notwendig CM in M umrechnen
         IF (ANTI(KPT) .EQ. 0) THEN
            IF (TIEF(KPT,1) .GE. 1.) NT = 1                  ! dann sind es CM !
         END IF
         IF (NT .EQ. 1)                         ! dann wird durch 100. geteilt !
     *       TIEF(KPT,ANTI(KPT)+1) = TIEF(KPT,ANTI(KPT)+1)/100.
C........falls nicht sortiert - Meldung
         IF (TIEF(KPT,ANTI(KPT)+1) .LT. TIEF(KPT,ANTI(KPT))) THEN
            WRITE (6,'(/A)') ' Daten sind nicht sortiert !'
            CALL RET
            GOTO 200
         END IF
         ANTI(KPT) = ANTI(KPT)+1
         WRITE (6,'(2F12.3)') TIEF(KPT,ANTI(KPT)),FELD(140,ANTI(KPT))
         GOTO 290
C
  292    CONTINUE
         KEN(140) = KPT
         IF (JSN .EQ. 'J') THEN
            TOP = 0.0
            BOT = TIEF(KPT,ANTI(KPT))
         END IF
         WRITE (6,'(/,A,I4)') ' Anzahl der gelesenen Werte: ',ANTI(KPT)
         CLOSE (24, STATUS='DELETE')
         CALL RET
         GOTO 200
      END IF
C______________________________________________________________________________
C.....Vp-Daten lesen
      IF (M1 .EQ. 'C') THEN
         WRITE (6,'(/,A)')  ' Vp - Datensatz lesen'
         WRITE (6,'(A/)')   ' ********************'
         KPT = 7
         ANTI(KPT) = 0
         NT = 0
         KPTEXT(KPT) = 'SCHALLGESCHWINDIGKEIT'
         FILIN='SYS$USER:[GROBE]'//KERN(1:4)//KERN(6:6)//'VP.HG'
         OPEN  (23, FILE=FILIN, STATUS='OLD')
C
  275    READ  (23, *, END=277, ERR=239) TIEF(KPT,ANTI(KPT)+1), 
     *             FELD(17,ANTI(KPT)+1), FELD(18,ANTI(KPT)+1)
         ANTI(KPT) = ANTI(KPT)+1
         WRITE (6,'(3F12.3)')            TIEF(KPT,ANTI(KPT)),
     *             FELD(17,ANTI(KPT)), FELD(18, ANTI(KPT))
         GOTO 275
C
  277    CONTINUE
         KEN(17) = KPT
         KEN(18) = KPT
         WRITE (6,'(/,A,I4)') ' Anzahl der gelesenen Werte: ',ANTI(KPT)
         CLOSE (23)
         CALL RET
         GOTO 200
      END IF
C
C.....zu Daten einfuehren
      IF (M1 .EQ. '1') GOTO 210
      IF (M1 .EQ. '2') GOTO 220
      IF (M1 .EQ. '3') GOTO 230
C______________________________________________________________________________
C-----Probentiefen eingeben
  210 CONTINUE
      WRITE (6,'(/,A)') ' Eingabe von Probentiefen in cm (99999 = EXIT)'
      WRITE (6,'(A,/)') ' ********************************************'
  211 WRITE (6,'(A,I4,A)') '$', ANTI(KPT)+1, '.Probe  > '
      READ  (5,'(I6)', ERR=213) IDAT
      IF (IDAT .EQ. 99999) THEN
         WRITE (6,'(/,A)') ' *** Ende der Eingabe ***'
         WRITE (6,'(/,A,I4)') 
     *         ' Anzahl der eingegebenen Werte: ',ANTI(KPT)
         CALL RET
         GOTO 200                                                               
      END IF  
      TIEF (KPT,ANTI(KPT)+1) = FLOAT(IDAT)/100.
      IF (TIEF(KPT,ANTI(KPT)+1) .LE. TIEF(KPT,ANTI(KPT))) THEN
         WRITE (6,'(//A//)') ' Fehler im Datensatz !'
         ANTI(KPT) = 0
         CALL RET
         GOTO 211
      END IF
      ANTI(KPT) = ANTI(KPT)+1
      GOTO 211
  213 CALL MIST
      GOTO 211
C______________________________________________________________________________
C-----Probentiefen  berechnen
  220 CONTINUE     
      WRITE (6,'(/,A)') ' Berechnung aequidistanter Probentiefen'  
      WRITE (6,'(A)')   ' **************************************'
      WRITE (6,'(A)')   ' (Eingaben in cm)'
      WRITE (6,'(/,A)') '$1. Probentiefe       > '
      READ  (5,*,ERR=202) I1T
      WRITE (6,'(A)')   '$letzte Probentiefe   > '
      READ  (5,*,ERR=202) ILT
      WRITE (6,'(A)')   '$Probenabstand        > '
      READ  (5,*,ERR=202) IA
      DO N = I1T, ILT, IA
         ANTI(KPT) = ANTI(KPT)+1         
         TIEF (KPT,ANTI(KPT)) = FLOAT(N)/100.
      END DO
      WRITE (6,'(/,A,I4)') ' Anzahl der berechneten Werte: ',ANTI(KPT)
      CALL RET
      GOTO 200
C______________________________________________________________________________
C-----Probentiefen lesen
  230 CONTINUE
      WRITE (6,'(/,A)') ' Probentiefen lesen'
      WRITE (6,'(A)')   ' ******************'
      WRITE (6,'(/,A)') '$Filename [ATK$USER:[GEOLOGIE]1.DAT] > '
      READ  (5,'(A)') FILIN
      IF (FILIN .EQ. ' ') FILIN = 'ATK$USER:[GEOLOGIE]1.DAT'
      WRITE (6,'(/,A)')'$Werte in <CM> oder <M> gespeichert ?  [M] '
      READ  (5,'(1A)') JN
      CALL CAPS(JN)
C
      OPEN  (23, FILE=FILIN, STATUS='OLD')
  231 READ  (23, *, END=232, ERR=239) TIEF(KPT,ANTI(KPT)+1)
      IF (JN .EQ. 'C') 
     *   TIEF(KPT,ANTI(KPT)+1) = TIEF(KPT,ANTI(KPT)+1)/100.
      IF (ANTI(KPT) .GT. 1) THEN
      IF (TIEF(KPT,ANTI(KPT)+1) .LE. TIEF(KPT,ANTI(KPT))) THEN
         WRITE (6,'(/A/)') ' Fehler im Datensatz !'
         ANTI(KPT) = 0
         CALL RET
         GOTO 200
      END IF
      END IF
      ANTI(KPT) = ANTI(KPT)+1
      GOTO 231
C
  232 WRITE (6,'(/,A,I4)') ' Anzahl der gelesenen Werte: ',ANTI(KPT)
      CLOSE (23)
      CALL RET
      GOTO 200
  239 CALL MIST
      GOTO 200
C______________________________________________________________________________
C-----Probentiefen listen
  240 CONTINUE
      CALL KENT(KPT)
      WRITE (6,'(/,X,A,I2,2X,A,/)') 'Kennung: ', KPT, KPTEXT(KPT)
      DO I=1, ANTI(KPT)
         IF (KPT .GT. 10 .OR. KPT .LE. 20) THEN
            WRITE (6,'(X,F6.0,3X,F10.3,A,F12.3,A)') 
     *        FLOAT(I), TIEF(KPT-10,I), ' m    ', TIEF(KPT,I), ' k.y.'
         ELSE
            WRITE (6,'(X,F6.0,3X,F12.3)') FLOAT(I), TIEF(KPT,I)
         END IF
      END DO
      CALL RET
      GOTO 200
C______________________________________________________________________________
C-----Probentiefen einfuegen
  250 CONTINUE
      CALL KENT(KPT)
      WRITE (6,'(/,A)') ' Tiefen einfuegen  (<Return> = EXIT)'
      WRITE (6,'(A)')   ' ***********************************'
  251 WRITE (6,'(/,A)')   '$Neue Probentiefe in cm   ==> '
      READ  (5,'(A)') AT
      IF (AT .EQ. ' ') GOTO 200
      READ (AT,*,ERR=2001) ITNEW
      TNEW = FLOAT(ITNEW)/100.
C
      DO I = 1, ANTI(KPT)
         IF (TIEF(KPT,I) .EQ. TNEW) THEN
            WRITE (6,'(/,A)') ' Tiefe existiert bereits !'
            GOTO 250
         ELSE IF (TIEF(KPT,I) .GT. TNEW) THEN
            DO J = 1, NPAR
               IF (KEN(J) .EQ. KPT) THEN
                  DO K = ANTI(KPT)+1,I+1,-1
                     FELD(J,K) = FELD(J,K-1)
                  END DO
                  FELD(J,I) = 9999.0
               END IF
            END DO
C
            ANTI(KPT) = ANTI(KPT) + 1
            DO J = ANTI(KPT), I+1, -1
               TIEF (KPT,J) = TIEF (KPT,J-1)
            END DO
            TIEF(KPT,I) = TNEW
            WRITE (6,'(A)') ' Tiefe eingefuegt '
            GOTO 251             
         END IF
      END DO
C
      ANTI(KPT) = ANTI(KPT)+1
      TIEF(KPT,ANTI(KPT)) = TNEW
      WRITE (6,'(/,A)') ' Tiefe angehaengt '
      GOTO 251
C______________________________________________________________________________
C-----Probentiefen loeschen
  260 CONTINUE
      CALL KENT(KPT)
      WRITE (6, '(/,A)') '$Probenserie vollstaendig loeschen ?  [N]'
      READ  (5, '(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. 'J') THEN
         ANTI(KPT) = 0
         KPTEXT(KPT) = ' '
         DO I = 1,NPAR
            IF (KEN(I) .EQ. KPT) KEN(I) = 0
         END DO
         WRITE (6, '(/,A)') ' Probenserie geloescht !'
         CALL RET
         GOTO 200
      END IF
  261 CONTINUE
      CALL BEGIN(III)
      IF (III .EQ. 99999) GOTO 200
      DO K = III,ANTI(KPT)
         TIEF(KPT,K) = TIEF(KPT,K+1)
         DO IA = 1, NPAR
            IF (KEN(IA) .EQ. KPT) FELD(IA,K) = FELD(IA,K+1)
         END DO
      END DO         
      ANTI(KPT) = ANTI(KPT) - 1
      WRITE (6, '(/,A)') ' Probentiefe geloescht !'
      GOTO 261
C______________________________________________________________________________
C-----Kernanfang/-ende aendern
  270 CONTINUE
      WRITE (6, '(/,A,F8.2)')' Kernanfang (m) :   alter Wert -> ', TOP
      WRITE (6, '(A)')       '$                   neuer Wert -> '
      READ  (5,*, ERR=270) TOP
      WRITE (6, '(/,A,F8.2)')' Kernende  (m) :    alter Wert -> ', BOT
      WRITE (6, '(A)')       '$                   neuer Wert -> '
      READ  (5,*, ERR=270) BOT
      GOTO 200
C______________________________________________________________________________
C-----Kommentar aendern
  280 CONTINUE
      CALL KENT(KPT)
      IF (KPT .EQ. 0) GOTO 200
      WRITE (6,'(/,2A)') ' Kommentar : ', KPTEXT(KPT)
      WRITE (6,'(A)')     
     *      ' ___________________________________________________'
      READ  (5,'(A)') KPTEXT(KPT)
      GOTO 200
C
C==============================================================================
C-----Datensatz bearbeiten
 3001 CALL MIST
  300 CONTINUE
      TYPE *, CLS
      WRITE (6,301)
  301 FORMAT (//,
     *14X,'              Menue SEDIMENTPARAMETER'/
     *14X,'              ======================='//
     *14X,' eingeben ........................................<1>'/
     *14X,' berechnen  ......................................<2>'/
     *14X,' lesen ...........................................<3>'/
     *14X,' Daten lesen + auf Tiefen umrechnen ..............<4>'//
     *14X,' korrigieren .....................................<5>'/
     *14X,' listen ..........................................<6>'/
     *14X,' loeschen ........................................<7>'/
     *14X,' Kennung aendern .................................<8>'/
     *14X,' undefinierte Werte ..............................<9>'//
     *14X,' HAUPTMENUE .................................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5,'(A)') M2
      IF (M2 .EQ. '1') GOTO 310
      IF (M2 .EQ. '2') GOTO 320
      IF (M2 .EQ. '3') GOTO 330
      IF (M2 .EQ. '4') GOTO 340
      IF (M2 .EQ. '5') GOTO 350
      IF (M2 .EQ. '6') GOTO 360
      IF (M2 .EQ. '7') GOTO 370
      IF (M2 .EQ. '8') GOTO 380
      IF (M2 .EQ. '9') GOTO 390
      GOTO 1000
C
C-----Daten eingeben
  310 CONTINUE
      CALL PAR(INKEN)
      IF (INKEN .EQ. 0) GOTO 300
      CALL KENT(KPT)
      IF (KPT .EQ. O) GOTO 300
      CALL BEGIN(III)
      IF (III .EQ. 99999) GOTO 300
  312 CONTINUE
      WRITE (6, '(/,A)') ' Dateneingabe  (99999 = EXIT)'
      WRITE (6, '(A,/)') ' ***************************'
      KEN(INKEN)=KPT
      DO I = III,ANTI(KPT)
  311     CONTINUE
          ZW = FELD(INKEN,I)
          WRITE (6,'(A,F6.0,A,F12.3,A)')
     *     '$',FLOAT(I),' Probe   ', (TIEF(KPT,I)),' m    => '      
         READ  (5,*,ERR=319) FELD(INKEN,I)
         IF (FELD(INKEN,I) .EQ. 99999.) THEN
            WRITE (6,'(/,A)')' * vorzeitige Beendigung der Eingabe *'
            FELD(INKEN,I) = 0.0
            IF (ZW .NE. 0.0) FELD(INKEN,I) = ZW
            CALL RET
            GOTO 300
         END IF
      END DO
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
      CALL RET
      GOTO 300
  319 CALL MIST
      GOTO 311
C..............................................................................
C-----Daten eingeben und berechnen
  320 CONTINUE
      TYPE *, CLS
      WRITE (6,321)
  321 FORMAT (//,
     *14X,'                EINGABE/BERECHNUNG'//
     *14X,' Wassergehalt ....................................<1>'/
     *14X,' C-Gehalt ........................................<2>'/
     *14X,' Opalgehalt ......................................<3>'/
     *14X,' % Kies/Sand/Silt/Ton ............................<4>'/
     *14X,' Sandfraktionen ..................................<5>'/
     *14X,' Siltfraktionen ..................................<6>'/
     *14X,' Scherfestigkeit .................................<7>'/
     *14X,' Dichte ..........................................<8>'/
     *14X,' Menue SEDIMENTPARAMETER ....................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5, '(A)') M2A
      IF (M2A .EQ. ' ') GOTO 300
      CALL KENT(KPT)
      IF (KPT .EQ. 0) GOTO 320
      CALL BEGIN(III)
      IF (III .EQ. 99999) GOTO 320
      IF (M2A .EQ. '1') GOTO 1310
      IF (M2A .EQ. '2') GOTO 1320
      IF (M2A .EQ. '3') GOTO 1330
      IF (M2A .EQ. '4') GOTO 1340
      IF (M2A .EQ. '5') GOTO 1350
      IF (M2A .EQ. '6') GOTO 1360
      IF (M2A .EQ. '7') GOTO 1370
      IF (M2A .EQ. '8') GOTO 1380
      GOTO 300
C
C-----Wassergehalt berechnen
 1310 CONTINUE
      KEN(2) = KPT
      KEN(3) = KPT
      DO I=III,ANTI(KPT)
 1311    CONTINUE
         WRITE (6,'(/,A,/)') ' ----------------------------------------'
         WRITE (6,'(X,I5,A,F12.3,A))') I,'. Probe  ', TIEF(KPT,I), ' m'
         WRITE (6,'(A)') '$Gewicht Probenglas            > '
         READ  (5,*,ERR=1319) GLAS
         IF (GLAS .EQ. 0.) GOTO 1319
         IF (GLAS .EQ. 99999.) GOTO 320
         WRITE (6,'(A)') '$Gewicht Probe nass + Glas     > '
         READ  (5,*,ERR=1319) GNASS
         IF (GNASS .EQ. 0.) GOTO 1319
         IF (GNASS .EQ. 99999.) GOTO 320
         WRITE (6,'(A)') '$Gewicht Probe trocken + Glas  > '
         READ  (5,*,ERR=1319) GTROK
         IF (GTROK .EQ. 0.) GOTO 1319
         IF (GTROK .EQ. 99999.) GOTO 320
         IF (GLAS .EQ. GNASS .OR. GTROK .EQ. GNASS 
     *       .OR. GLAS .EQ. GTROK) GOTO 1319
         FELD (2,I) = 100/(GTROK-GLAS)*((GNASS-GLAS)-(GTROK-GLAS))
         FELD (3,I) = 100/(GNASS-GLAS)*((GNASS-GLAS)-(GTROK-GLAS))
         WRITE (6,'(/,X,A,F6.2)') '% Wasser/Trockengewicht: ',FELD(2,I)
         WRITE (6,'(X,A,F6.2)')   '% Wasser/Nassgewicht   : ',FELD(3,I)
      END DO
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
      CALL RET
      GOTO 320
 1319 CALL MIST
      GOTO 1311
C
C-----C-Gehalt berechnen
 1320 CONTINUE
      KEN(20) = KPT
      KEN(21) = KPT
      KEN(22) = KPT
      WRITE (6,'(/,A)') '$<C>org oder <K>arbonat berechnen ? '
      READ  (5,'(A)') CK
      CALL CAPS(CK)
      DO I=III,ANTI(KPT)
 1321    CONTINUE
         WRITE (6,'(/,A,/)') ' ----------------------------------------'
         WRITE (6,'(X,I5,A,F12.3,A))') I,'. Probe  ', TIEF(KPT,I), ' m'
         WRITE (6,'(A)') '$% C gesamt     > '
         READ  (5,*,ERR=1329) CGES
         IF (CGES .EQ. 99999.) GOTO 320
         IF (CK .EQ. 'C') WRITE (6,'(A)') '$% C Karbonat   > '
         IF (CK .EQ. 'K') WRITE (6,'(A)') '$% C org        > '
         READ  (5,*,ERR=1329) CKAR
         IF (CKAR .EQ. 99999.) GOTO 320
         IF (CK .EQ. 'C') THEN
            FELD (20,I) = CKAR*8.33
            FELD (21,I) = CGES-CKAR
         ELSE IF (CK .EQ. 'K') THEN
            FELD (20,I) = (CGES-CKAR)*8.33
            FELD (21,I) = CKAR
         END IF
         IF (FELD(20,I) .LT. 0.) GOTO 1329
         IF (FELD(21,I) .LE. 0.) GOTO 1329
         FELD (22,I) = FELD(20,I)/FELD(21,I)
         WRITE (6,'(/,X,A,F6.2)') '% Karbonat    : ', FELD(20,I)
         WRITE (6,'(X,A,F6.2)')   '% C-organisch : ', FELD(21,I)
         WRITE (6,'(X,A,F6.2)')   '  Karb/C-org. : ', FELD(22,I)
      END DO
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
      CALL RET
      GOTO 320
 1329 CALL MIST
      GOTO 1321
C
C-----Opalgehalt berechnen
 1330 CONTINUE
      WRITE (6, '(A)') ' not available ! '
      GOTO 320
C
C-----% KIES/Sand/Silt/Ton berechnen
 1340 CONTINUE
      WRITE (6,'(A)') '$<T>ara/Brutto- oder <N>etto-gewichte ? [Exit] '
      READ (6,'(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. ' ') GOTO 320
      WRITE (6, '(A)') '$Gewicht Kies eingeben  J/N  [N] ? '
      READ (5,'(A)') JNN
      CALL CAPS(JNN)
 1342 CONTINUE
      IF (JNN .EQ. 'J') KEN(31) = KPT
      KEN(29) = KPT
      KEN(32) = KPT
      KEN(33) = KPT
      KEN(34) = KPT
      DO I=III,ANTI(KPT)
 1341    CONTINUE
         WRITE (6,'(/,A,/)') ' ----------------------------------------'
         WRITE (6,'(X,I5,A,F12.3,A))') I,'. Probe  ', TIEF(KPT,I), ' m'
         IF (JN .EQ. 'N') THEN
            IF (JNN .EQ. 'J') THEN
               WRITE (6,'(A)') '$Gewicht Kies   > '
               READ  (5,*,ERR=1349) GKIES
               IF (GKIES .EQ. 99999.) GOTO 320
            END IF
            WRITE (6,'(A)') '$Gewicht Sand   > '
            READ  (5,*,ERR=1349) GSAND
            IF (GSAND .EQ. 99999.) GOTO 320
            WRITE (6,'(A)') '$Gewicht Silt   > '
            READ  (5,*,ERR=1349) GSILT
            WRITE (6,'(A)') '$Gewicht Ton    > '
            READ  (5,*,ERR=1349) GTON
         ELSE IF (JN .EQ. 'T') THEN
            IF (JNN .EQ. 'J') THEN
               WRITE (6,'(A)') '$Gewicht Kies   > '
               READ  (5,*,ERR=1349) GKIES
               IF (GKIES .EQ. 99999.) GOTO 320
            END IF
            WRITE (6,'(A)') '$Sand Tara    > '
            READ  (5,*,ERR=1349) TSAND
            IF (TSAND .EQ. 99999.) GOTO 320
            WRITE (6,'(A)') '$Sand Brutto  > '
            READ  (5,*,ERR=1349) BSAND
            GSAND = BSAND - TSAND
            WRITE (6,'(A)') '$Silt Tara    > '
            READ  (5,*,ERR=1349) TSILT
            WRITE (6,'(A)') '$Silt Brutto  > '
            READ  (5,*,ERR=1349) BSILT
            GSILT = BSILT - TSILT
            WRITE (6,'(A)') '$Ton Tara     > '
            READ  (5,*,ERR=1349) TTON
            WRITE (6,'(A)') '$Ton Brutto   > '
            READ  (5,*,ERR=1349) BTON
            GTON = BTON - TTON
         END IF
C
         WRITE (6,'(X,A)') ' '
         IF (JNN .EQ. 'J') THEN
            IF (GKIES+GSAND+GSILT+GTON .EQ. 0.) GOTO 1349
            GESAMT = 100/(GKIES+GSAND+GSILT+GTON)
            FELD(31,I) = GESAMT*GKIES
            WRITE (6,'(X,A,F6.2)')'% Kies:  ',FELD(31,I)
         END IF
         IF (GSAND+GSILT+GTON .EQ. 0.) GOTO 1349
         GESAMT = 100/(GSAND+GSILT+GTON)
         FELD(32,I) = GESAMT*GSAND         
         WRITE (6,'(X,A,F6.2)')   '% Sand:   ',FELD(32,I)
         FELD(33,I) = GESAMT*GSILT
         WRITE (6,'(X,A,F6.2)')   '% Silt:   ',FELD(33,I)
         FELD(34,I) = GESAMT*GTON         
         WRITE (6,'(X,A,F6.2)')   '% Ton:    ',FELD(34,I)
         IF (FELD(34,I) .EQ. 0. .OR. FELD(33,I) .EQ. 0.) THEN
            FELD(29,I) = 0.
            GOTO 1346
         END IF
         FELD(29,I) = FELD(33,I)/FELD(34,I)
 1346    WRITE (6,'(X,A,F6.2)')   'Silt/Ton: ',FELD(29,I)
      END DO      
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
 1348 CONTINUE
      CALL RET
      GOTO 320
 1349 CALL MIST
      GOTO 1341
C
C-----Sandfraktionen eingeben und berechnen
 1350 CONTINUE
      DO I = III, ANTI(KPT)
 1352    WRITE (6,'(/,I5,A,F12.3,A)') I,'. Probe ', TIEF(KPT,I), ' m'
         WRITE (6,'(A)')
     *         ' ---------------------------------------------'
         SUMGSF = 0.0
         WRITE (6,'(/,A)') '$Gewicht Fraktion Kies  (>2 mm)       => '
         READ  (5,*,ERR=1359) GKIES   
         IF (GKIES .EQ. 99999.) GOTO 1354
         DO J = 1,5
            WRITE (6,'(3A)') '$Gewicht Fraktion ', GFRAK(J), '   => '
            READ  (5,*,ERR=1359) GSF(J)
            IF (GSF(J) .EQ. 99999.) GOTO 1354
            SUMGSF = SUMGSF+GSF(J)
         END DO
         FELD(273,I) = 100/(GKIES+SUMGSF) * GKIES
         WRITE (6,'(/,A,4X,A,F6.2)')
     *          ' Fraktion Kies  (>2 mm)', ' in %/Sand = ', FELD(273,I)
         DO J = 1,5
            FELD(273+J,I) = 100/SUMGSF*GSF(J)
            WRITE (6,'(3A,F6.2)') 
     *           ' Fraktion ', GFRAK(J), ' in %/Sand = ', FELD(273+J,I)
         END DO
      END DO
      GOTO 1355
 1354 CONTINUE
      WRITE (6,'(/,A,I5,A,F12.3,A)') 
     * ' Ende der Eingabe bei der ', I, '. Probe = ', TIEF(KPT,I), ' m'
 1355 CONTINUE
      DO I = 1,6
         KEN(272+I) = KPT
      END DO
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
      CALL RET
      GOTO 320
 1359 CALL MIST
      GOTO 1352
C
C-----Siltfraktionen eingeben und berechnen
 1360 CONTINUE
      GSF(1) = 100.
      DO I = III, ANTI(1)
 1362    WRITE (6,'(/,I5,A,F12.3,A)') I,'. Probe ', TIEF(KPT,I), ' m'
         WRITE (6,'(A)') ' --------------------------------'
         SUMGSF = 0.0
         DO J = 2,6        ! Daten eingeben
            WRITE (6,'(3A)') '$', SSILT(J-1), '         => '
            READ  (5,*,ERR=1369) GSF(J)
            IF (GSF(J) .EQ. 99999.) GOTO 1364
         END DO
         FELD(334,I) = GSF(6)
         DO J = 1,5        ! Daten berechnen
            FELD(278+J,I) = GSF(J) - GSF(J+1)
            WRITE (6,'(X,2A,F6.2)') 
     *           SSILT(J), 'in %/Silt = ', FELD(278+J,I)
         END DO
      END DO
C
 1364 CONTINUE
      WRITE (6,'(/,A,I5,A,F12.3,A)') 
     * ' Ende der Eingabe bei der ', I, '. Probe = ', TIEF(KPT,I), ' m'
      KEN(334) = KPT
      DO I = 1,5
         KEN(278+I) = KPT
      END DO
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
      CALL RET
      GOTO 320
 1369 CALL MIST
      GOTO 1362
C
C-----Scherfestigkeit berechnen
 1370 CONTINUE
      WRITE (6,'(/,A)') '$Messkopf 500 oder 1500 ?  > '
      READ (5,*, ERR=1370) MKOPF
      IF (MKOPF .EQ. 500)  SFACT = 0.049
      IF (MKOPF .EQ. 1500) SFACT = 0.147
      KEN(9) = KPT
      KEN(11) = KPT
      DO I=III,ANTI(KPT)
 1371    CONTINUE
         WRITE (6,'(/,A,/)') ' ----------------------------------------'
         WRITE (6,'(X,I5,A,F12.3,A))') I,'. Probe ', TIEF(KPT,I), ' m'
         SCHERF = 0.
         DO ISCH = 1,3
            WRITE (6,'(A,I4,A)') '$', ISCH, '.  Messwert  > '
            READ  (5,*,ERR=1379) SCHER(ISCH)
            IF (SCHER(ISCH) .EQ. 99999.) GOTO 320
            SCHERF = SCHERF+SCHER(ISCH)
         END DO
         SCHERF = SCHERF/3.
         FELD (11,I) = SCHERF
         FELD ( 9,I) = SCHERF * SFACT
         WRITE (6,'(X,A,F8.2)') 'Skalenteile     : ', FELD (11,I)
         WRITE (6,'(X,A,F8.2)') 'Scherfestigkeit : ', FELD ( 9,I)
      END DO
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
      CALL RET
      GOTO 320
 1379 CALL MIST
      GOTO 1371
C
C-----Dichte berechnen
 1380 CONTINUE
      KEN(16) = KPT
      DO I=III,ANTI(KPT)
 1381    CONTINUE
         WRITE (6,'(/,A,/)') ' ----------------------------------------'
         WRITE (6,'(X,I5,A,F12.3,A))') I,'. Probe ', TIEF(KPT,I), ' m'
         WRITE (6,'(/,A)') '$Becher         - Gewicht   > '
         READ  (5,*,ERR=1389) BECHG
         IF (BECHG .EQ. 99999.) GOTO 320
         WRITE (6,'(A)')   '$               - Volumen   > '
         READ  (5,*,ERR=1389) BECHV
         WRITE (6,'(A)')   '$               - Korrektur > '
         READ  (5,*,ERR=1389) BECHK
         WRITE (6,'(/,A)') '$Becher + Probe - Gewicht   > '
         READ  (5,*,ERR=1389) PROBG
         WRITE (6,'(A)')   '$               - Volumen   > '
         READ  (5,*,ERR=1389) PROBV
         WRITE (6,'(A)')   '$               - Korrektur > '
         READ  (5,*,ERR=1389) PROBK
         BECHV = BECHV - BECHK
         PROBV = PROBV - PROBK
         VOLUM = PROBV - BECHV
         GEWIC = PROBG - BECHG
         GEWIC = GEWIC - GEWIC*0.035   ! Salzkorrektur
         FELD (16,I) = GEWIC/VOLUM
         WRITE (6,'(/,X,A,F8.2,A)') 'Dichte: ', FELD (16,I), ' g/ccm'
      END DO
      WRITE (6, '(/,A)') ' *** Ende der Eingabe ***' 
      CALL RET
      GOTO 320
 1389 CALL MIST
      GOTO 1381
C..............................................................................
C-----Daten lesen
  330 CONTINUE
      NIN = 0
      IF (FILIN .EQ. ' ') THEN
         WRITE (6, '(/,A)') '$Filename [ATK$USER:[GEOLOGIE]1.DAT]  > '
         READ  (5, '(A)') FILIN
         IF (FILIN .EQ. ' ') FILIN = 'ATK$USER:[GEOLOGIE]1.DAT'
      ELSE 
         WRITE (6, '(/,3A)') '$Filename [', FILIN, '] > '
         READ  (5, '(A)') FILI
         IF (FILI .NE. ' ') FILIN = FILI
      END IF
C
      WRITE (6,'(A)') '$Einen <1> oder mehrere <2> Parameter lesen ? '
      READ  (5,*, ERR=330) NPP
      CALL KENT(KPT)
      IF (KPT .EQ. 0) GOTO 300
C
C.....einen Parameter lesen
  331 IF (NPP .EQ. 1) THEN
         WRITE (6, '(A)') '$Wievielte Spalte  > '
         READ  (5, *, ERR=331) SP
         CALL PAR(INKEN)
         IF (INKEN .EQ. 0) GOTO 300
         OPEN (22, FILE=FILIN, ERR=999, STATUS='OLD')
         WRITE (6, '(/,3A)') ' File ',FILIN,' wird gelesen...'
         DO I = 1,ANTI(KPT)
            IF (SP .EQ. 1) 
     *        READ (22, *, END=332, ERR=3001) FELD(INKEN,I)
            IF (SP .GT. 1) 
     *        READ (22,*,END=332,ERR=3001) (D,II=1,SP-1), FELD(INKEN,I)
         END DO                
  333    KEN(INKEN)=KPT
         CLOSE (22)
         CALL RET
         GOTO 300
  332    WRITE (6,'(/,X,I4,A,I4,A)') 
     *         I, ' Daten fuer ', ANTI(KPT), ' Probenpunkte gelesen !'
         GOTO 333      
C
C.....mehrere Parameter lesen
      ELSE
  334    WRITE (6, '(/,A)')     '$Anzahl der Parameter : '
         READ  (5,*, ERR=334) NPARA
         WRITE (6,'(A)')     '$fortlaufende Kennungen [N] : '
         READ  (5,'(A)') JNN
         CALL CAPS(JNN)
         IF (JNN .EQ. 'J') THEN
            WRITE (6,'(A)')   '$erste Kennung : '
            READ  (5,*, ERR=334) K1
            DO I = 1, NPARA
               PF(I) = K1 - 1 + I
            END DO                  
         ELSE
            DO I = 1, NPARA
               WRITE (6,'(/,X,I4,A)') I, '. Parameter:'
               CALL PAR(INKEN)
               IF (INKEN .EQ. 0) GOTO 300
               PF(I) = INKEN
            END DO
         END IF
C
  335    WRITE (6,'(A)')        '$erste Spalte ueberlesen [J] : '
         READ  (5,'(A)') JJN
         CALL CAPS(JJN)
         LR = 0
  336    IF (NPARA .GT. 8) THEN
            WRITE (6,'(A)')     '$Recordlaenge (0=Standard) : '
            READ  (5,*, ERR=336) LR
         END IF
C
         IF (LR .EQ. 0) 
     *       OPEN (22, FILE=FILIN, ERR=999, STATUS='OLD')
         IF (LR .NE. 0) 
     *       OPEN (22, FILE=FILIN, RECL=LR ,ERR=999, STATUS='OLD')
C
         WRITE (6, '(/,3A)') ' File ',FILIN,' wird gelesen...'
         DO I2 = 1, ANTI(KPT)
            IF (JJN .NE. 'N')
     *     READ (22, *, ERR=999) D, (FELD(PF(II), I2), II=1, NPARA)
            IF (JJN .EQ. 'N')
     *     READ (22, *, ERR=999) (FELD(PF(II), I2), II=1, NPARA)
         END DO
C
         DO I = 1, NPARA
            KEN (PF(I)) = KPT
         END DO
         CLOSE (22)
         CALL RET
         GOTO 300
      END IF
C
C-----lineare Interpolation
  340 CONTINUE
      READ (22, *, END=342, ERR=3001) XIN(NIN+1,1), XIN(NIN+1,2)
      NIN = NIN+1
      GOTO 340
  342 CLOSE(22)
      XB = .01                      ! Anfangspunkt
      XI = .01                      ! Abstand
      XL = TIEF(KPT,ANTI(KPT))+0.1  ! Endpunkt
      IS=0
      JS=1
      XZ=XB-XI
    1 XZ=XZ+XI
      IF (XZ-XL) 2,2,99
    2 IS=IS+1
      XOUT(IS,1)=XZ
      IF(XZ-XIN(1,1))3,3,4
    3 XOUT(IS,2)=XIN(1,2)
      GO TO 1
    4 IF (XZ-XIN(NIN,1))6,5,5
    5 XOUT(IS,2)=XIN(NIN,2)
      GO TO 1
    6 IF(XZ-XIN(JS,1))9,8,7
    7 IF(XZ-XIN(JS+1,1))8,8,9
    8 XOUT(IS,2)=XIN(JS,2)+(XIN(JS+1,2)-XIN(JS,2))*
     1 (XZ-XIN(JS,1))/(XIN(JS+1,1)-XIN(JS,1))
      GO TO 1
    9 JS=JS+1
      IF (JS-NIN)6,10,10
   10 JS=JS-1
      GO TO 5
   99 CONTINUE
      WRITE (6, '(A)') ' ... und interpoliert ...'
      IN = 1
      DO L = 1, INT(TIEF(KPT,ANTI(KPT))*100.)
         IF (XOUT(L,1) .EQ. TIEF(KPT,IN)) THEN   
             FELD (INKEN,IN) = XOUT(L,2)
             IN = IN+1
         END IF
      END DO
      KEN(INKEN)=KPT
      GOTO 300
C
C-----Daten korrigieren
  350 CONTINUE
      WRITE (6,'(/,A)') ' Daten korrigieren'
      WRITE (6,'(A)')   ' *****************'
      CALL PAR(INKEN)
      IF (INKEN .EQ. 0) GOTO 300
      IF (KEN(INKEN) .EQ. 0) THEN
         WRITE (6,'(A)') ' Parameter nicht vorhanden !'
         CALL RET
         GOTO 300
      END IF
      KPT = KEN(INKEN)
      CALL BEGIN(III)
      IF (III .EQ. 99999) GOTO 300
  351 WRITE (6,'(X,A,F12.3,A,F8.2)')
     * PARA(INKEN),(TIEF(KPT,III)),' m  alter Wert ->', FELD(INKEN,III)  
      WRITE (6,'(A)')
     * '$                                              
     *          neuer Wert -> '
      READ  (5,*,ERR=3001) FELD(INKEN,III)
      GOTO 350
C
C-----Daten listen
  360 CONTINUE
      WRITE (6,'(/,A)') ' Daten listen'
      WRITE (6,'(A)')   ' ************'
      CALL PAR(INKEN)
      IF (INKEN .EQ. 0) GOTO 300
      IF (KEN(INKEN) .EQ. 0) THEN
         WRITE (6,'(A)') ' Parameter nicht vorhanden !'
         CALL RET
         GOTO 300
      END IF
      KPT = KEN(INKEN)
      DO I = 1,ANTI(KPT)
         WRITE (6, '(X,F6.0,3X,F12.3,X,F10.3)') 
     *         FLOAT(I), TIEF(KPT,I), FELD(INKEN,I)
      END DO
      CALL RET
      GOTO 300
C
C-----Daten loeschen
  370 CONTINUE
      WRITE (6,'(/,A)') ' Parameter loeschen'
      WRITE (6,'(A)')   ' ******************'
      CALL PAR(INKEN)
      IF (INKEN .EQ. 0) GOTO 300
      KEN(INKEN) = 0
      WRITE (6, '(/,3A)') ' Parameter ', PARA(INKEN), 'geloescht !'
      CALL RET
      GOTO 300
C
C-----Kennung aendern
  380 CONTINUE
      WRITE (6,'(/,A)') ' Kennung aendern'
      WRITE (6,'(A)')   ' ***************'
      WRITE (6,'(/,A)') ' ALTE Kennung: '
      CALL PAR(IPALT)
      IF (IPALT .EQ. 0) GOTO 300
      WRITE (6,'(/,A)') ' NEUE Kennung: '
      CALL PAR(IPNEU)
      IF (IPNEU .EQ. 0) GOTO 300
      DO I = 1, ANTI(KEN(IPALT))
         FELD(IPNEU,I) = FELD(IPALT,I)
      END DO
      KEN (IPNEU) = KEN (IPALT)
      KEN (IPALT) = 0
      GOTO 300
C
C-----undefinierte Werte erzeugen
  390 CONTINUE
      WRITE (6,'(/,A)') ' Parameter mit undefinierten Werten fuellen'
      WRITE (6,'(A,/)') ' ******************************************'
      CALL PAR(IUNDEF)
      IF (IUNDEF .EQ. 0) GOTO 300
      CALL KENT (KTU)
      IF (KTU .EQ. 0) GOTO 300
      KEN (IUNDEF) = KTU
      DO I = 1, ANTI(KEN(IUNDEF))
         FELD(IUNDEF,I) = 9999.
      END DO
      GOTO 300
C
C-----moegliche Parameter und Kennungen listen
  399 CONTINUE
      TYPE *, CLS
      WRITE (6,'(/,X,A)') 'Tiefenkennungen:'
      WRITE (6,'(X,A)') LLL
      DO I = 1,10
         WRITE (6,'(X,25A)') TKTEXT(I)
      END DO
      CALL RET
C
      WRITE (6,'(/,X,A)') 'Kennungen und Sedimentparameter:'
      WRITE (6,'(X,A)') LLL
      DO I = 1, NPAR
         WRITE (6,'(X,A40,A20)') PARA(I), ENGL(I)
         IF (INT(FLOAT(I)/20.) .EQ. FLOAT(I)/20.) THEN
            CALL RET
            WRITE (6,'(//,X,A)') LLL
         END IF
      END DO
      GOTO 1000
C------------------------------------------------------------------------------
C-----lithologische Grenzen eingeben
  500 CONTINUE
      GOTO 1000
C------------------------------------------------------------------------------
C-----Daten auswerten
 6001 CALL MIST
  600 CONTINUE
      TYPE *, CLS
      WRITE (6,601)
  601 FORMAT (//,
     *14X,'                     AUSWERTUNG'/
     *14X,'                     =========='//
     *14X,' Parameter berechnen .............................<1>'/
     *14X,' Komponentenanalyse ..............................<2>'/
     *14X,' Korngroessen ....................................<3>'/
     *14X,' Tonminerale .....................................<4>'//
     *14X,' Statistik .......................................<5>'/
     *14X,' Grafik ..........................................<6>'//
     *14X,' +-/* ............................................<7>'/
     *14X,' Mean, Min, Max ..................................<8>'//
     *14X,' Zeit berechnen ..................................<9>'/
     *14X,' CROSPEC-File anlegen ............................<0>'//
     *14X,' HAUPTMENUE .................................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5, '(A)') M2B
      IF (M2B .EQ. '1') GOTO 610
      IF (M2B .EQ. '2') GOTO 620
      IF (M2B .EQ. '3') GOTO 630
      IF (M2B .EQ. '4') GOTO 640
      IF (M2B .EQ. '5') GOTO 650
      IF (M2B .EQ. '6') GOTO 660
      IF (M2B .EQ. '7') GOTO 670
      IF (M2B .EQ. '8') GOTO 680
      IF (M2B .EQ. '9') GOTO 690
      IF (M2B .EQ. '0') GOTO 695
      GOTO 1000
C..............................................................................
C.....Parameter berechnen falls notwendig
C
C-----IRD-Parameter berechnen
  610 CONTINUE
      WRITE (6,'(/A)') ' IRD-PARAMETER...'
      IF (KEN(30) .NE. 0) THEN
         WRITE (6,'(A)') ' IRD-Parameter bereits vorhanden !'
         GOTO 612
      ELSE IF (KEN(27) .EQ. 0) THEN
         WRITE (6,'(A)') ' IRD-Daten nicht vorhanden !'
         GOTO 612
      END IF
C
      Z = 1
      IF (NINT(TIEF(1,1)*100.) .EQ. 1 .OR. 
     *    NINT(TIEF(1,1)*100.) .EQ. 2) THEN
         Z = 2
         FELD (30,1) = 0.
      END IF
C
      DO I = 3, ANTI(KEN(27))-2
         IF (NINT(TIEF(1,Z)*100.) .EQ. I) THEN
         FELD(30,Z) = (FELD(27,I-2) + FELD(27,I-1) + FELD(27,I) +
     *           FELD(27,I+1) + FELD(27,I+2))/5.
         Z = Z + 1
         END IF
      END DO
      KEN(30) = 1
      WRITE (6,'(/,A)') ' IRD-Parameter berechnet und unter Kennung 30
     * gespeichert !'
C
C.....Wassergehalte rechnen
  612 CONTINUE
      WRITE (6,'(/A)') ' WASSERGEHALT...'
      IF (KEN(2) .EQ. 0 .AND. KEN(3) .EQ. 0) THEN
         WRITE (6,'(A)') ' Wassergehalte nicht vorhanden !'
         GOTO 614
      ELSE IF (KEN(2) .NE. 0 .AND. KEN(3) .NE. 0) THEN
         WRITE (6,'(A)') ' beide Wassergehalte bereits vorhanden !'
         GOTO 614
      ELSE IF (KEN(2) .EQ. 0) THEN
         DO I = 1, ANTI(KEN(3))
            FELD(2,I) = (100*FELD(3,I))/(100-FELD(3,I))
            IF (FELD(3,I) .EQ. 9999.) FELD(2,I) = 9999.
         END DO
         WRITE (6,'(A)') ' Wassergehalt vom Trockengewicht berechnet'
         KEN(2) = KEN(3)
         GOTO 614
      ELSE IF (KEN(3) .EQ. 0) THEN
         DO I = 1, ANTI(KEN(2))
            FELD(3,I) = (100*FELD(2,I))/(100+FELD(2,I))
            IF (FELD(2,I) .EQ. 9999.) FELD(3,I) = 9999.
         END DO
         WRITE (6,'(A)') ' Wassergehalt vom Nassgewicht berechnet'
         KEN(3) = KEN(2)
      END IF
  614 CONTINUE
C
C.....Dichten rechnen
      WRITE (6,'(/A)') ' FEUCHTRAUMDICHTE/POROSITAET/KORNDICHTE...'
      IF (KEN(16) .EQ. 0 .OR. KEN(3) .EQ. 0) THEN
         WRITE (6,'(A)') ' Trockendichte nicht vorhanden !'
         GOTO 616
      END IF
      DO I = 1, ANTI(KEN(2))
      IF (FELD(16,I) .EQ. 9999.) THEN
         FELD(4,I) = 9999.
         FELD(5,I) = 9999.
         FELD(15,I) = 9999.
         GOTO 615
      END IF
C..Feuchtraumdichte
         FELD(4,I) = 100./((100.-FELD(3,I))/FELD(16,I)-FELD(3,I)*3.5
     * /(96.5*2.1)+FELD(3,I)*100./(96.5*1.024))
C..Porositaet
         FELD(5,I) = 100*(FELD(3,I)*100./(96.5*1.024))/((100-FELD(3,I))
     * /FELD(16,I)-FELD(3,I)*3.5/(96.5*2.1)+FELD(3,I)*100.
     * /(96.5*1.024))
C..Korndichte
         FELD(15,I) = ((100.-FELD(3,I))-(FELD(3,I)*3.5/96.5))/((100-
     * FELD(3,I))/FELD(16,I)-FELD(3,I)*3.5/(96.5*2.1))
  615 END DO
      WRITE (6,'(A)') 
     *      ' Feuchtraumdichte/Porositaet/Korndichte berechnet'
      KEN(4) = KEN(2)
      KEN(5) = KEN(2)
      KEN(15) = KEN(2)
  616 CONTINUE
C
  619 CONTINUE
      CALL RET
      GOTO 600
C
C..............................................................................
C-----Sandkomponentenanalyse auswerten
  620 CONTINUE
      TYPE *, CLS
      WRITE (6,'(/,A)') ' <S>andkomponentenanalyse (extern)'
      WRITE (6,'(A)')   '$<A>uswertung (intern)            => '
      READ  (5,'(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. 'S') GOTO 621
      IF (JN .EQ. 'A') GOTO 624
      GOTO 600
C
  621 CONTINUE
      WRITE (6,'(/,A)')'$Wieviele Partikel sollen gezaehlt werden ? '
      READ  (5,*, ERR=621) NKORN
      WRITE (6,'(A)')  '$mit der wievielten Probe beginnen ? '
      READ  (5,*, ERR=621) I1
      FILOUT = KERN(1:4)//'.'//KERN(6:6)//'SAKA'
      WRITE (6,'(/,2A)') '$Daten werden gespeichert in File ',FILOUT
      OPEN (11, FILE=FILOUT, STATUS='NEW')
      DO I = I1,ANTI(1)
         WRITE (6,'(X,I4,A,5X,F12.3,A)') I, '. Probe ',TIEF(1,I), ' m'
         CALL COUNTER (TIEF(1,I),NKORN)
         CALL RET
      END DO
      CLOSE (11)
      GOTO 600
  624 CONTINUE
      WRITE (6,'(/,A)') ' Umrechnung Sand% auf gesamt%'
      WRITE (6,'(A)')   ' berechnete Parameter :'
      DO I = 71,107,2
         IF (KEN(I) .EQ. 0) GOTO 625
         WRITE (6,'(2X,A)') PARA(I)
         DO IT = 1,ANTI(KEN(I))
            FELD (I+1,IT) = FELD(I,IT)*FELD(32,IT)/100.
         END DO
         KEN(I+1) = KEN(I)
  625 END DO   
      CALL RET
      GOTO 600
C..............................................................................
C-----Korngroessen auswerten
  630 CONTINUE
      TYPE *, CLS
      WRITE (6,631)
  631 FORMAT (//,
     *14X,'                    KORNGROESSEN'//
     *14X,' Sedigraphdaten uebernehmen ......................<1>'/
     *14X,' Fallrohrdaten uebernehmen .......................<2>'//
     *14X,' Korngroessenparameter berechnen .................<3>'/
     *14X,' Grafische Auswertung ............................<4>'//
     *14X,' Menue AUSWERTUNG ...........................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5, '(A)') M2C
      IF (M2C .EQ. '1') GOTO 1610
      IF (M2C .EQ. '2') GOTO 1620
      IF (M2C .EQ. '3') GOTO 1630
      IF (M2C .EQ. '4') GOTO 660   !Menue Grafik
      GOTO 600
C
C.....Sedigraph-Daten uebernehmen
 1610 CONTINUE
      TYPE *, CLS
      WRITE (6,'(/,A)') ' Sedigraph-Daten lesen'
      WRITE (6,'(A,/)') ' *********************'
      WRITE (6,'(/,A)') '$Directory der Rohdaten  -> '
      READ  (5, '(A)') DIFFDIR
      ISF = 0
      DO I=1, ANTI(1)
         WRITE (CIN, '(I4.4)') IFIX((TIEF(1,I)*100.)+0.5)
         WRITE (FILIN,'(40A,2A4,2A,A4)')
     *    DIFFDIR, CIN, KERN(1:4), '.', KERN(6:6), 'SILT'
         OPEN (11,FILE=FILIN,STATUS='OLD',ERR=1619)
         WRITE (6,'(X,A)') FILIN
         READ (11,*,ERR=6001) DUMDAT, DUMDAT
         ISF = ISF + 1
         SEDI(1) = 100.
         DO J=2,51
            READ (11,*,ERR=6001) DUMDAT, SEDI(J)
            FELD(283+J-1,I) = SEDI(J-1)-SEDI(J)
            IF (FELD(283+J-1,I) .LT. 0.0) FELD(283+J-1,I) = 0.0
         END DO
         FELD(334,I) = SEDI(51)     !Fraktion <2um in % vom Silt
 1612 CONTINUE
      END DO
      WRITE (6,'(/,X,A,I4,A,I4,A)')  
     * 'von', ANTI(1), ' Proben  ', ISF, ' Sedigraph-Files eingelesen'
      IF (ISF .NE. 0) THEN
         DO I = 1,51
            KEN(283+I) = 1
         END DO
      END IF
      CALL RET
      GOTO 600
 1619 WRITE (6,'(20X,3A)') ' File ', FILIN, ' nicht vorhanden !'
      GOTO 1612
C
C.....Fallrohrdaten uebernehmen
 1620 CONTINUE
      TYPE *, CLS
      WRITE (6,'(/,A)') ' Fallrohr-Daten lesen'
      WRITE (6,'(A,/)') ' ********************'
      WRITE (6,'(/,A)') '$Directory der Rohdaten  -> '
      READ  (5, '(A)', ERR=1620) DIFFDIR
      ISF = 0
      DO I=1, ANTI(1)
         WRITE (CIN, '(I4.4)') IFIX((TIEF(1,I)*100.)+0.5)
         WRITE (FILIN,'(40A,A4,2A,A6)')
     *    DIFFDIR, CIN, KERN(3:4), '_G.PHI'
         OPEN (11,FILE=FILIN,STATUS='OLD',ERR=1629)
         OPEN (12,FILE=FILIN,STATUS='NEW')
         WRITE (6,'(X,A)') FILIN
         ISF = ISF+1
C
C.....stoerende Zeichen loeschen
         DO I2 = 1,60
            READ (11,'(A)') DCHAR
            DO K = 1,80
               IF (DCHAR(K:K) .EQ. '+' .OR. DCHAR(K:K) .EQ. '-'
     *        .OR. DCHAR(K:K) .EQ. '#' .OR. DCHAR(K:K) .EQ. '*')
     *         DCHAR(K:K) = ' '
            END DO
            WRITE (12,'(X,A)') DCHAR
         END DO
         REWIND (12)
         CLOSE  (11)
C
C.....erste 16 Zeilen ueberlesen
         DO I2 = 1,16
           READ (12,'(A)') DCHAR
         END DO
C
C.....Daten lesen
         DO I2 = 1,41
            READ (12,*) DAT1, DAT2, DAT3, DAT4
            FELD (181+I2,I) = DAT4*FELD(32,I)/100.
            WRITE (6,'(X,3F8.2)') FELD(32,I), DAT4, FELD(181+I2,I)
         END DO
         CLOSE (12,STATUS='DELETE')
 1622    CONTINUE
      END DO
      WRITE (6,'(/,X,A,I4,A,I4,A)')  
     * 'von', ANTI(1), ' Proben  ', ISF, ' Fallrohr-Files eingelesen'
      IF (ISF .NE. 0) THEN
         DO I = 1,41
            KEN(181+I) = 1
         END DO
      END IF
      CALL RET
      GOTO 600
 1629 WRITE (6,'(20X,3A)') ' File ', FILIN, ' nicht vorhanden !'
      GOTO 1622
C
C.....Korngroessenparameter berechnen
 1630 CONTINUE
      TYPE *, CLS
      IF (KEN(46) .NE. 0) THEN
         WRITE (6,'(/,A)') 
     *' Korngroessenparameter wurden bereits berechnet !'
         WRITE (6,'(A)') '$Parameter neu berechnen  [N] ? '
         READ (5,'(A)', ERR=1630) JN
         CALL CAPS(JN)
         IF (JN .NE. 'J') GOTO 630
         KEN (46) = 0
      END IF
C
C.....Hauptschleife............................................................
      KPT = KEN(33)
      DO I = 1, ANTI(KPT)              
C
 7213 CONTINUE
      WRITE (6,'(/,X,3A,F12.3,A)') 'KORNGROESSENAUSWERTUNG  ***  Kern '
     *, KERN, '  *  Probe ', TIEF(KPT,I), ' m'
C
C.....% Kies absolut berechnen
      IF (KEN(31) .EQ. 0 .AND. KEN(273) .NE. 0) THEN
         FELD(31,I) = (FELD(273,I)*FELD(32,I))/100.
         KEN(31) = KEN(32)
      END IF
C
C.....fuer Silt in % vom Silt...
C.....wenn fuer Silt nur volle phi eingegeben wurden, auf 1/10 phi umrechnen
      IF (KEN(279) .NE. 0) THEN
         DO IS = 1,5
            DO ISS = 1,10
               FELD(283+ISS+(IS-1)*10,I) = FELD(278+IS,I)/10.
            END DO
         END DO
         DO IS = 1,50
            KEN(283+IS) = 1
         END DO
      END IF
C
C.....fuer Silt und Sand in % von der Gesamtprobe...
C.....wenn fuer Silt & Sand volle phi eingegeben wurden, auf 1/10 phi umrechnen
      IF (KEN(163) .NE. 0) THEN
         DO IS = 1,5
            DO ISS = 1,10
               FELD(171+ISS+(IS-1)*10,I) = FELD(157+IS,I)/10.
               FELD(221+ISS+(IS-1)*10,I) = FELD(162+IS,I)/10.
            END DO
         END DO
         DO IS = 1,50
            KEN(221+IS) = 1
         END DO
         GOTO 434
      END IF
C
C.....Ausreisser im Silt korrigieren
C.....ersten Wert eliminieren
      FELD (284,I) = FELD (285,I)
C.....zu kleine Werte korrigieren
      DO IS = 294, 331
         IF (FELD (IS,I) .LT. 0.5) THEN
            WSIN = (FELD(IS-1,I)+FELD(IS-2,I))/2.
            WDEX = (FELD(IS+1,I)+FELD(IS+2,I))/2.
            IF (WSIN .GT. WDEX) FELD (IS,I) = WDEX
            IF (WSIN .LE. WDEX) FELD (IS,I) = WSIN
         END IF
      END DO
C.....viel zu grosse Werte korrigieren
      DO IS = 294, 332
         IF (ABS(FELD(IS,I) - FELD(IS+1,I)) .GT. 1.5)
     *           FELD (IS,I) = FELD (IS-1,I)
      END DO
C.....zu grosse Einzelwerte korrigieren
      DO IS = 294, 331
         IF (FELD(IS,I) .GT. ((FELD(IS+1,I)+FELD(IS+2,I))/2.)+.5 .AND.
     *       FELD(IS,I) .GT. ((FELD(IS-1,I)+FELD(IS-2,I))/2.)+.5)
     *       FELD(IS,I) = (FELD(IS-1,I)+FELD(IS+1,I))/2.
      END DO
C.....Silt glaetten
      DO IS = 285,332
         FELD(IS,I)=FELD(IS-1,I)*.15+FELD(IS,I)*.7+FELD(IS+1,I)*.15
      END DO
C
C.....Siltfraktionen ohne Ton berechnen
      SUMSI = 0.0
      DO IS = 284,333
         SUMSI = SUMSI + FELD(IS,I)     
      END DO
      DO IS = 284,333
         FELD(IS,I) = 100./SUMSI*FELD(IS,I)
      END DO
C
C.....Tonanteil der Siltfraktion zu % Ton addieren, Sand/Silt/Ton neu berechnen
      TONSI  = FELD(34,I) + FELD(334,I)
      SUMSST = TONSI + FELD(32,I) + FELD(33,I)
      FELD (32,I) = 100./SUMSST*FELD(32,I) 
      FELD (33,I) = 100./SUMSST*FELD(33,I) 
      FELD (34,I) = 100./SUMSST*TONSI
      FELD (334,I) = 0.0
C
C.....wenn nur % Sand vorhanden, setze alle Sandwerte = %Sand/50.
      IF (KEN(278) .EQ. 0 .AND. KEN(182) .EQ. 0) THEN
         DO IS = 1,50
            FELD(171+IS,I) = FELD(32,I)/50.
         END DO
         GOTO 7300
      END IF
C
C.....rechne fuenf Sandfraktionen auf 1/10 phi-Fraktionen um
 7215 CONTINUE
      IF (KEN(182) .EQ. 0) THEN
         DO I1 = 1,5
            DO I2 = 1,10
            FELD(171+I2+((I1-1)*10),I) = FELD(273+I1,I)*FELD(32,I)/1000.
            END DO
         END DO
      END IF
C
C.....berechne Siltfraktionen
 7300 CONTINUE
      DO IS = 1,50
         FELD(221+IS,I) = FELD(283+IS,I)*FELD(33,I)/100.
      END DO      
C
C.....4.0 - 4.5 PHI korrigieren (Sedigraph-Fehler !)
      IF (KEN(279) .NE. 0) GOTO 434
      FELD(222,I) = FELD(221,I)*.5+FELD(228,I)*.5
      FELD(223,I) = FELD(221,I)*.4+FELD(228,I)*.6
      FELD(224,I) = FELD(221,I)*.3+FELD(228,I)*.7
      FELD(225,I) = FELD(221,I)*.2+FELD(228,I)*.8
      FELD(226,I) = FELD(221,I)*.1+FELD(228,I)*.9
      FELD(227,I) = FELD(228,I)
C
C.....Gesamtverteilung glaetten
 7217 CONTINUE
      MWERT(1) = FELD(172,I)
      MWERT(2) = FELD(173,I)
      MWERT(3) = FELD(174,I)
      MWERT(4) = FELD(175,I)
      DO IG = 1,92
         MWERT(IG+4) = FELD(171+IG  ,I)*.03 + FELD(171+IG+1,I)*.06 +
     *                 FELD(171+IG+2,I)*.11 + FELD(171+IG+3,I)*.15  +
     *                 FELD(171+IG+4,I)*.3  + FELD(171+IG+5,I)*.15  +
     *                 FELD(171+IG+6,I)*.11 + FELD(171+IG+7,I)*.06  +
     *                 FELD(171+IG+8,I)*.03
      END DO
      MWERT(97) = FELD(268,I)
      MWERT(98) = FELD(269,I)
      MWERT(99) = FELD(270,I)
      MWERT(100) = FELD(271,I)
      DO IG = 1,100
         FELD(171+IG,I) = MWERT(IG)
      END DO
C
      DO IG = 1,10
         MWERT(IG) = 
     *        FELD(259+IG,I)*.25+FELD(260+IG,I)*.5+FELD(261+IG,I)*.25
      END DO
      DO IG = 1,10
         FELD(260+IG,I) = MWERT(IG)
      END DO
C
C.....% Sand/Silt neu berechnen
      SUMSS = 0.0
      DO I5 = 1,100
         SUMSS = SUMSS+FELD(171+I5,I)
      END DO      
      DO I5 = 1,100
         FELD(171+I5,I) = FELD(171+I5,I)*((100.-FELD(34,I))/SUMSS)
      END DO
C
C.....Uebergang Silt-Ton in Gesamtverteilung glaetten
      DT = (FELD(34,I)/40. - FELD(268,I))/4.
      FELD (269,I) = FELD(268,I) + DT
      FELD (270,I) = FELD(268,I) + DT*2.
      FELD (271,I) = FELD(268,I) + DT*3.
C      
C.....FOLK-Parameter der Gesamtfraktion berechnen
  434 CONTINUE
      YP1 = 0.0
      YPN = 0.0
      GSUMX(1) = -1.0
      GSUMY(1) = 0.0
      DO IS = 1,100
         GSUMX(IS+1) = GSUMX(IS) + 0.1
         GSUMY(IS+1) = GSUMY(IS) + FELD(171+IS,I)
      END DO
      GSUMX(101) = 13.
      GSUMY(101) = 100.0
      CALL SPLINE (GSUMX, GSUMY, 101, YP1, YPN, Y2)
C
      DO J = 1,7                                   ! fuer 7 Perzentile
         DO R = -1.,13.,.1                         ! 1/10 phi-Schritte vorw.
            CALL SPLINT (GSUMX, GSUMY, Y2, 101, R, Y)
            IF (Y .GT. PROD(J)) THEN
               DO S = R,-1.,-0.01                ! 1/100 phi-Schritte rueckw.
                  CALL SPLINT (GSUMX, GSUMY, Y2, 101, S, Y)
                  IF (Y .LE. PROD(J)) THEN
                     F(J) = S
                     GOTO 435
                  END IF
               END DO
            END IF
         END DO
  435 CONTINUE
      END DO     
C
      FELD(35,I) = (F(2)+F(4)+F(6))/3.
      FELD(36,I) = ((F(2)+F(6)-2*F(4))/(2*(F(6)-F(2))))+((F(1)+F(7)
     *               -2*F(4))/(2*(F(7)-F(1))))
      FELD(37,I) = (F(7)-F(1))/(2.44*(F(5)-F(3)))
      FELD(38,I) = ((F(6)-F(2))/4)+((F(7)-F(1))/6.6)
      DO J = 1,7
         FELD(42+J,I) = (F(J))
      END DO
C      
C.....FOLK-Parameter der Siltfraktion berechnen
      GSUMY(1) = 0.0
      GSUMX(1) = 4.0
      DO IS = 1,50
         GSUMY(IS+1) = GSUMY(IS) + FELD(283+IS,I)
         GSUMX(IS+1) = GSUMX(IS) + 0.1
      END DO
      GSUMY(51) = 100.0
      GSUMX(51) = 9.0
      CALL SPLINE (GSUMX, GSUMY, 51, YP1, YPN, Y2)
C
      DO J = 1,7                                   ! fuer 7 Perzentile
         DO R = 4., 9., .1                         ! 1/10 phi-Schritte vorw.
            CALL SPLINT (GSUMX, GSUMY, Y2, 51, R, Y)
            IF (Y .GT. PROD(J)) THEN
               DO S = R,-1.,-0.01                ! 1/100 phi-Schritte rueckw.
                  CALL SPLINT (GSUMX, GSUMY, Y2, 51, S, Y)
                  IF (Y .LE. PROD(J)) THEN
                     F(J) = S
                     GOTO 437
                  END IF
               END DO
            END IF
         END DO
  437 CONTINUE
      END DO     
C
      FELD(39,I) = (F(2)+F(4)+F(6))/3.
      FELD(40,I) = ((F(2)+F(6)-2*F(4))/(2*(F(6)-F(2))))+((F(1)+F(7)
     *               -2*F(4))/(2*(F(7)-F(1))))
      FELD(41,I) = (F(7)-F(1))/(2.44*(F(5)-F(3)))
      FELD(42,I) = ((F(6)-F(2))/4)+((F(7)-F(1))/6.6)
C
C.....Daten schreiben
      DO II = 1,19
         WRITE (6, '(X,A40,A,F10.2)') PARA(30+II),' :', FELD(30+II,I)
      END DO
      END DO
C.....Ende der Hauptschleife...................................................
C
C.....Kennungen setzen
      KEN(31) = KEN(32)
      DO II = 1, ANTI(1)
         IF (FELD(43,II) .NE. 0) THEN
            DO I = 1,15
               KEN(34+I) = KEN(32)
            END DO
            DO I = 1,100
               KEN(171+I) = KEN(32)
            END DO
            GOTO 630
         END IF
      END DO
      CALL RET
      GOTO 630
C..............................................................................
C
C-----Tonminerale auswerten
  640 CONTINUE
      TYPE *, CLS
      WRITE (6,'(/,A)') ' *********************************'
      WRITE (6,'(  A)') ' *** Auswertung Tonmineralogie ***'
      WRITE (6,'(  A)') ' *********************************'
      WRITE (6,'(/,A)') '$<1> 2-40 grad  <2> 40-78 grad  > '
      READ (5, *, ERR=640) NGRAD
      WRITE (6,'(A)')   '$<P>lotten oder <A>uswerten ?   > '
      READ (5,'(A)', ERR=640) JNN
      CALL CAPS(JNN)
      WRITE (6,'(A)')   '$Directory der Rohdaten         > '
      READ (5,'(A)', ERR=640) DIFFDIR
      IF (DIFFDIR .EQ. ' ') DIFFDIR = '[...DIFF]'
      CALL KENT (KPT)
      CALL BEGIN (IA)
      IF (IA .EQ. 99999) GOTO 600
      IENDE = 0
      IF (JNN .EQ. 'A') 
     *   OPEN (77,FILE=KERN(1:4)//'.'//KERN(6:6)//'TON',STATUS='NEW')
      DO II = IA, ANTI(KPT)
         IENDE = IENDE+1
         IF (II .EQ. ANTI(KPT)) IENDE = 99999
         WRITE (COUT,'(I5.5)') IFIX((TIEF(KPT,II)*100.)+0.5)
         IF (NGRAD .EQ. 1) WRITE (FILIN,'(A20,A5,A4,2A,A4)') 
     *      DIFFDIR, COUT, KERN(1:4), '.', KERN(6:6), 'clay'
         IF (NGRAD .EQ. 2) WRITE (FILIN,'(A20,A5,A4,2A,A4)') 
     *      DIFFDIR, COUT, KERN(1:4), '.', KERN(6:6), 'DIF2'
         CALL DIANE (IENDE, NGRAD, FILIN, JNN)
      END DO
      IF (JNN .NE. 'A') THEN
         CALL RET
         GOTO 600
      ELSE IF (JNN .EQ. 'A') THEN
         CLOSE (77)
      END IF
C
C.....einlesen der Daten
      OPEN (66,FILE=KERN(1:4)//'.'//KERN(6:6)//'TON',STATUS='OLD')
      IZEL = 0
      DO I = IA, ANTI(KPT)
C........Rohdaten
         READ (66, '(X, 8F8.0)') (FELD(359+IZ,I), IZ=1,8)
         READ (66, '(X, 6F8.0)') (FELD(367+IZ,I), IZ=1,6)
C........Prozente
         READ (66 ,'(X, 8F8.2)') (FELD( 49+IZ,I), IZ=1, 8) 
C........Verhaeltnisse
         READ (66 ,'(X,11F8.2)') 
     *         (FELD(63+IZ,I), IZ=1,7), (FELD(373+IZ,I), IZ=1,4)
C........Zaehler fuer fehlende Proben
         IF (FELD(50,I) .EQ. 9999.) IZEL=IZEL+1
      END DO
      CLOSE (66, STATUS='DELETE')
C
C.....Kennungen setzen
      DO I = 1,18
         KEN(359+I) = 1
      END DO
      DO I = 1,8
         KEN(49+I) = 1
      END DO
      DO I = 1,7
         KEN(63+I) = 1
      END DO
      CALL SBELL
      IF (IZEL .NE. ANTI(KPT)) WRITE (6,'(/,X,A,I3,A,I3,A)') 'von ',
     * ANTI(KPT), ' Proben nur ', IZEL, ' Rohdatensaetze vorhanden !'
      CALL RET
      GOTO 600
C=============================================================================
C-----Statistik
  650 CONTINUE
      TYPE *, CLS
      WRITE (6,651)
  651 FORMAT (//,
     *14X,'                      STATISTIK'//
     *14X,' Mittelwert, Standardabweichung, Varianz..........<1>'/
     *14X,' Autokorrelation .................................<2>'/
     *14X,' Fourier Analyse .................................<3>'//
     *14X,' Korrelation .....................................<4>'/
     *14X,' lineare Regression ..............................<5>'/
     *14X,' Polynomregression ...............................<6>'/
     *14X,' Crosskorrelation ................................<7>'//
     *14X,' Clusteranalyse ..................................<8>'/
     *14X,' Komponentenanalyse ..............................<9>'/
     *14X,' Faktorenenanalyse ...............................<0>'//
     *14X,' Menue AUSWERTUNG ...........................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5, '(A)') M2D
      IF (M2D .EQ. ' ') GOTO 600
      WRITE (6, '(/,A)') ' Bildschirmausgabe      =  6'
      WRITE (6, '(  A)') ' vollstaendige Ausgabe  = 77'
  652 WRITE (6, '(/,A)') '$Logische Nummer der Ausgabe -> '
      READ  (5, '(I4)', ERR=652) LUW
      IF (M2D .EQ. '1') CALL VARI
      IF (M2D .EQ. '2') CALL AUTOCR
      IF (M2D .EQ. '3') CALL FOURER
      IF (M2D .EQ. '4') CALL BICOR
      IF (M2D .EQ. '5') CALL LINFIT
      IF (M2D .EQ. '6') CALL POLYD
      IF (M2D .EQ. '7') CALL CROSCR
      IF (M2D .EQ. '8') CALL CLUSTR
      IF (M2D .EQ. '9') CALL PCA
      IF (M2D .EQ. '0') CALL FACT
      CALL RET
      GOTO 650
C
C-----Grafik
  660 CONTINUE
      TYPE *, CLS
      WRITE (6,661)
  661 FORMAT (//,
     *14X,'                      GRAFIK'//
     *14X,' X-Y Plot ........................................<1>'/
     *14X,' Dreiecksdarstellung .............................<2>'//
     *14X,' Korngroessenverteilung ..........................<3>'/
     *14X,' Tonmineralanalyse ...............................<4>'//
     *14X,' Menue AUSWERTUNG ...........................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5, '(A)') M2D
      IF (M2D .EQ. ' ') GOTO  600
      IF (M2D .EQ. '1') GOTO 6670
      IF (M2D .EQ. '2') GOTO 6680
      IF (M2D .EQ. '3') GOTO 6690
      IF (M2D .EQ. '4') GOTO  640  ! Tonmineralauswertung
      GOTO 660
C----------------------------------------------------------------------------
C.....Korrelationsdiagramm
 6670 CONTINUE
      WRITE (6,'(/A)') '$Parameter gegen Tiefe/Zeit plotten ?  [N] '
      READ  (5,'(A)') JNN
      CALL CAPS(JNN)
      IF (JNN .EQ. 'J') THEN
         CALL KENT(KPT)
         DO I = 1, ANTI(KPT)
            XX(I) = TIEF(KPT, I)
         END DO
         WRITE (6,'(/A)') '$Tiefe gegen Zeit plotten ?  [N] '
         READ  (5,'(A)') JJN
         CALL CAPS(JJN)    
         IF (JJN .EQ. 'J') THEN
            DO I = 1, ANTI(KPT)
               YY(I) = TIEF(KPT+10, I)        
            END DO
            IZ = ANTI(KPT)
         ELSE
 6673       CALL PAR(INKEN)
            IF (INKEN .EQ. 0) GOTO 660
            IF (KEN(INKEN) .NE. KPT) THEN
                WRITE (6,'(A)') ' Kennungen stimmen nicht ueberein !'
                GOTO 6673
            END IF
            IZ = 0
            DO I = 1, ANTI(KEN(INKEN))
 6674          XX(IZ+1) = FELD(INKEN,I)
               IF (XX(IZ+1) .EQ. 9999.) GOTO 6674
               IZ = IZ+1
            END DO
         END IF
         JNN = 'J'
         GOTO 6676
      END IF
C
      WRITE (6,'(/A)') '$Punkte verbinden ?  [N]    '
      READ  (5,'(A)') JNN
      CALL CAPS(JNN)
      WRITE (6,'(A)')  '$Regression zeichnen ?  [N] '
      READ  (5,'(A)') JN
      CALL CAPS(JN)
C.....Korrelation berechnen
      LUW = 117
      CALL POLYD
C.....Daten von polyd lesen, undef. Werte rauswerfen
      IZ = 0
      OPEN (12, FILE='FOR117.DAT', ERR=660, STATUS='OLD')
      READ (12, '(A)') CDUM
      DO IA = 1, ANTI(KEN(IP1))
 6675    READ (12,*) IDUM, XX(IZ+1), YY(IZ+1)
         IF (XX(IZ+1) .EQ. 9999. .OR. YY(IZ+1) .EQ. 9999.) GOTO 6675
         IZ = IZ + 1
      END DO
C
C.....Min und Max berechnen
 6676 CONTINUE
      PMIN1 = 10000.
      PMAX1 = -10000.
      PMIN2 = 10000.
      PMAX2 = -10000.
      DO IA = 1, IZ
         IF (XX(IA) .LT. PMIN1) PMIN1 = XX(IA)
         IF (XX(IA) .GT. PMAX1) PMAX1 = XX(IA)
         IF (YY(IA) .LT. PMIN2) PMIN2 = YY(IA)
         IF (YY(IA) .GT. PMAX2) PMAX2 = YY(IA)
      END DO
C______________________________________________________________________________
C.....grafische Darstellung 
17100 CONTINUE
      CALL LUGRAF (1, IOUT)
      CALL GOPEN
C.....Groesse und Position des Plots       
      CALL BGRAF(20.,20.,210.,150.)
      CALL BFRAME(.5)
Cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
C.....Achsenbeschriftung und Labels X-Achse
      IF (PMAX1 .GE. 1.) CALL BAXLAB (4.,2.5,0,0)
      IF (PMAX1 .LT. 1.) CALL BAXLAB (4.,2.5,1,0)
C.....Tickmarks fuer X-Achse
      CALL BTICKM(2)
C.....Werte fuer x-Achse runden
      CALL BSCLIN(1,PMIN1,PMAX1,VMIN,VMAX,NSTEP)
C.....X-Achse zeichnen
      CALL BAXIS(1,VMIN,0.0,VMAX,ENGL(IP1)//'$')
Cyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy
C.....Achsenbeschriftung und Labels Y-Achse
      IF (PMAX2 .GE. 1.) CALL BAXLAB (4.,2.5,0,0)
      IF (PMAX2 .LT. 1.) CALL BAXLAB (4.,2.5,1,0)
C.....Tickmarks fuer Y-Achse
      CALL BTICKM(2)
C.....Werte fuer y-Achse runden
      CALL BSCLIN(1,PMIN2,PMAX2,VMIN,VMAX,NSTEP)
C.....Y-Achse zeichnen
      CALL BAXIS(2,VMIN,0.0,VMAX,ENGL(IP2)//'$')
Cdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd
C.....Daten plotten
      CALL BMARKH(1.5)
      IF (IOUT .LT. 5)  CALL BMARKC(3)
      IF (JNN .EQ. 'J') CALL BMARK(4, +1)
      IF (JNN .NE. 'J') CALL BMARK(4, -1)
      CALL BLINE (XX,YY,IZ)
      IF (JN .NE. 'J') GOTO 17999
C.....Daten fuer Regressionsgerade lesen
17998 CONTINUE
      READ (12,'(X,3A)') CDUM
      READ (12,'(X,3A)') CDUM
      IB = 1
      DO IA = 1, 101
         READ (12,*) XXX, YYY
         IF (YYY .LT. VMIN .OR. YYY .GT. VMAX) GOTO 17996
         XX(IB) = XXX
         YY(IB) = YYY
         IB = IB+1
17996 CONTINUE
      END DO
C.....Regressionsgerade zeichnen
      IF (JN .EQ. 'J') THEN
         CALL BLICOL(6)
         CALL BLINE(XX,YY,IB-1)
      END IF
C.....Korrelationskoeffizient lesen und plotten
17997 CONTINUE
      READ (12,'(X,9A)') KR
      CLOSE (12, STATUS='DELETE')
      CALL GCHARC(2)
      CALL GCHAR(KR//'$',182.,40.,5.)
      CALL GCHARC(4)
      CALL GCHAR('Core$',182.,30.,3.5)
      CALL GCHAR(KERN//'$',198.,30.,3.5)
      CALL GCLOSE
17999 CONTINUE
      GOTO 660
C
C------------------------------------------------------------------------------
C.....Dreiecksdarstellung
 6680 CONTINUE
C.....Daten zuordnen
      WRITE (6,'(/,A)') ' -------------------------------------------'
      WRITE (6,'(A)') ' 1. Parameter'
      CALL PAR(IP1)
      IF (IP1 .EQ. 99999 .OR. IP1 .EQ. 0) GOTO 660
      WRITE (6,'(A)') ' 2. Parameter'
      CALL PAR(IP2)
      IF (IP2 .EQ. 99999 .OR. IP2 .EQ. 0) GOTO 660
      WRITE (6,'(A)') ' 3. Parameter'
      CALL PAR(IP3)
      IF (IP3 .EQ. 99999 .OR. IP3 .EQ. 0) GOTO 660
      IF (KEN(IP1) .NE. KEN(IP2) .OR. KEN(IP2) .NE. KEN(IP3)
     *    .OR. KEN(IP1) .NE. KEN(IP3)) THEN
         WRITE (6,'(A)') ' Probentiefen nicht identisch !'
         GOTO 660
      END IF
      WRITE (6,'(/,A)') '$mit Probentiefen ? [N] > '
      READ (5,'(A)') JN
      CALL CAPS (JN)
      WRITE (6,'(/,A)') '$Text : '
      READ (5,'(A)') ZI
      IF (ZI .NE. ' ') ZITAT = ZI//'$'
C
      CALL LUGRAF (1, IOUT)
      F1 = 1
      F2 = 1
      F3 = 1
      F4 = 1
ccc      IF (IOUT .LT. '5') THEN
ccc         F2 = 2     ! ROT
ccc         F3 = 3     ! GRUEN
ccc         F4 = 4     ! BLAU
ccc      END IF
C.....Dreieck zeichnen
      CALL GPRINT(0)
      CALL GOPEN
      CALL GWICOL(1.,F2)
      CALL GVECT(20.,20.,0)
      CALL GVECT(170.,20.,1)
      CALL GVECT(95.,150.,1)
      CALL GVECT(20.,20.,1)
      CALL GWICOL(.1,F2)
      CALL GVECT(95.,20.,0)
      CALL GVECT(132.5,85.,1)
      CALL GVECT(57.5,85.,1)
      CALL GVECT(95.,20.,1)
C.....Beschriftung
      CALL GCHARF('SIMP')
      CALL GNUMB(FLOAT(IP1),86.,156.,2.,0)
      CALL GNUMB(FLOAT(IP2),11.,8.,2.,0)
      CALL GNUMB(FLOAT(IP3),163.,8.,2.,0)
      CALL GWICOL(.1,F4)
      CALL GCHAR(KKEN//KERN//'$',130.,118.,3.) 
      IF (ZI .NE. ' ') CALL GCHAR(ZITAT,150.,109.,3.)
C.....Punkte zeichnen
      CALL GWICOL(1.4,F3)
      DO J = 1,ANTI(KEN(IP1))
         ZWI = 100./(FELD(IP3,J)+FELD(IP2,J)+FELD(IP1,J))
         X = FELD(IP3,J) * ZWI * .75 - FELD(IP2,J) * ZWI * .75 + 95
         Y = FELD(IP1,J) * ZWI * 1.3 + 20
         CALL GDOT(X,Y,1)
         IF (JN .EQ. 'J')
     *       CALL GNUMB((TIEF(KEN(IP1),J)*100.),X+1.,Y+1.,1.,0)
      END DO
      CALL GCLOSE
      GOTO 660
C------------------------------------------------------------------------------
C.....Korngroessen darstellen
 6690 CONTINUE
      GSUMX(1) = 0.0
      DO IS = 1,100
         GSUMX(IS+1) = GSUMX(IS)+0.1
      END DO
      GSUMX(101) = 14.0
C
      SUMX(1) = 0.0
      DO IS = 1,50
         SUMX(IS+1) = SUMX(IS)+0.1
      END DO
      SUMX(51) = 5.0
C
      YP1 = 0.0                                     ! Steigung im ersten Punkt
      YPN = 0.0                                     ! Steigung im letzten Punkt
      KPT = KEN(33)
C
      CALL BEGIN(III)
      IIN = 0
      DO I = III, ANTI(KPT) ! Anfang der Hauptschleife
C
C.....Teste ob Korngroessenparameter berechnet wurden
      IF (KEN(35) .EQ. 0) THEN
       WRITE(6,'(/,A)')' Korngroessenparameter wurden nicht berechnet !'
         CALL RET
         GOTO 660
      END IF
C
C.....grafische Darstellung der Korngroessenparameter
      IIN = IIN+1
      CALL LUGRAF (IIN, IOUT)
      WRITE (6,'(3A,F12.3,A)') ' GRAPHISCHE KORNGROESSENAUSWERTUNG  
     ****  Kern ', KERN, '  *  Probe ', TIEF(KPT,I), ' m'
      CALL GPRINT(0)
      CALL GOPEN
C
C.....Histogramm der Gesamtverteilung zeichnen
      CALL BGRAF (15.,15.,150.,75.)
      CALL BTICKM(2)
      CALL BAXLAB(3.,2.5,0,0)
      CALL BAXEND(2)
      CALL BAXIS (1,-2.,1.,13.,'p h i$')
      CALL BGRID (1,0)
      CALL BTICKM(2)
      CALL BAXLAB(3.,2.5,0,0)
      CALL BAXIS (2,0.,10.,50.,'$')
      CALL GCHAR('%/phi$',1.,94.,3.)

C
      DO J = 1,100
         IF (IOUT .LT. 3) CALL GSURFR(3)
         CALL RRECT 
     *  (25.+(J-1.), 15., 25.+J, 15.+FELD(171+J,I)*14.,0,.2)
         GSUMY(J) = 0.0
      END DO
C
C.....Kiesanteil
      IF (IOUT .LT. 3) CALL GWICOL (-1.,3)
      IF (IOUT .GE. 3) CALL GWICOL (-3.,1)
      IF(FELD (31,I) .LT. .1) GOTO 20
      CALL GVECT (25.,15.,0)
      CALL GVECT (25.,15.+FELD(31,I)*1.4,1)
      CALL GVECT (17.,15.+FELD(31,I)*1.4,1)
C
C.....Tonanteil
   20 CONTINUE
      CALL GVECT (125.,15.,0)
      CALL GVECT (125.,15.+FELD(34,I)*1.4,1)
      CALL GVECT (133.,15.+FELD(34,I)*1.4,1)
      CALL GVECT (125.,15.+FELD(34,I)*1.4/4.,0)
      CALL GVECT (165.,15.+FELD(34,I)*1.4/4.,1)
C
C.....Histogramm der Siltverteilung zeichnen
   21 CONTINUE
      CALL BGRAF (170.,15.,50.,75.)
      CALL BTICKM(2)
      CALL BAXLAB(3.,2.5,0,0)
      CALL BAXIS (1,4.,1.,9.,'p h i$')
      CALL BGRID(1,0)
      CALL BTICKM(2)
      CALL BAXLAB(0.,0.,999,999)
      CALL BAXIS(2,0.,10.,50.,'$')  
C
      DO J = 1,50
         IF (IOUT .LT. 3) CALL GSURFR(3)
         CALL RRECT 
     *  (170.+(J-1.), 15., 170.+J, 15.+FELD(283+J,I)*14.,0,.2)
         SUMY(J) = 0.0
      END DO
C
C.....Summenkurve der Gesamtverteilung zeichen
      CALL BGRAF (15.,100.,150.,75.)
      CALL BFRAME(.1)
      CALL BAXLAB(0.,0.,999,999)
      CALL BAXIS (1,-2.,1.,13.,'$')
      CALL BGRID(1,0)
      CALL BAXLAB(3.,2.5,0,0)
      CALL BTICKM(4)
      CALL BAXIS(2,0.,20.,100.,'$')  
      CALL GCHAR('%$',5.,180.,3.)
      IF (IOUT .LT. 3) CALL GWICOL (-1.,3)
      IF (IOUT .GE. 3) CALL GWICOL (-3.5,1)
C
      DO IS = 1,100
         GSUMY(IS+1) = GSUMY(IS) + FELD(171+IS,I)
      END DO
      GSUMY(101) = 100.0
C
      CALL SPLINE (GSUMX, GSUMY, 101, YP1, YPN, Y2)
      CALL GVECT  (25.,100.,0)
      DO X = 0.0,14.0,.01  
         CALL SPLINT (GSUMX, GSUMY, Y2, 101, X, Y)
         CALL GVECT  (25.+X*10.,100.+Y*.75,1)
      END DO
C
C.....Summenkurve der Siltverteilung zeichen
      CALL BGRAF (170.,100.,50.,75.)
      CALL BFRAME(.1)
      CALL BAXLAB(0.,0.,999,999)
      CALL BAXIS (1,4.,1.,9.,'$')
      CALL BGRID(1,0)
      CALL BTICKM(4)
      CALL BAXLAB(0.,0.,999,999)
      CALL BAXIS(2,0.,20.,100.,'$')  
C
      DO IS = 1,50
         SUMY(IS+1) = SUMY(IS) + FELD(283+IS,I)
      END DO
      SUMY(51) = 100.0
C
      CALL SPLINE (SUMX, SUMY, 51, YP1, YPN, Y2)
      CALL GVECT  (170.,100.,0)
      DO X = 0.0,5.0,.01  
         CALL SPLINT (SUMX, SUMY, Y2, 51, X, Y)
         CALL GVECT  (170.+X*10.,100.+Y*.75,1)
      END DO
C
C.....Kopfzeile schreiben
      IF (IOUT .LT. 3) THEN
         CALL GCHARF ('SMAL')
         PP = 1.
      ELSE 
         CALL GCHARF ('COMP')
         PP = 180.
         CALL GCHAR ('Core$',25.,PP,4.0)
         CALL GCHAR ('Sample$',73.,PP,4.0)
         CALL GCHAR ('Grain Size Analysis$',170.,PP,3.5)
      END IF
      CALL GCHAR (KERN//'$',41.,PP,4.0) 
      CALL GNUMB (TIEF(KPT,I) ,103.,PP,4.0,2)
      CALL GCHAR ('m$',118.,PP,3.0)
C
C.....Daten schreiben
      PO = 179.
      DO J = 1,19
         PA = 247.
         IF (FELD(30+J,I) .GE. 10.) PA = 245.
         IF (FELD(30+J,I) .LT.  0.) PA = 246.
         PO = PO - 7.
         IF (J .EQ. 5 .OR. J .EQ. 9 .OR. J .EQ. 13) PO = PO - 10.
         IF (IOUT .GE. 3) THEN
            CALL GCHAR (WORT(J)//'$' ,230.,PO,2.5)
            CALL GNUMB (FELD(30+J,I) ,PA,PO,2.5,2)
         ELSE
            CALL GNUMB (FELD(30+J,I) ,227.,PO,2.5,2)
         END IF
      END DO
C
C.....Hilfslinien zeichnen
      CALL GWICOL (-1.,1)
      CALL GVECT (15.,90.,0)
      CALL GVECT (15.,97.,1)
      CALL GVECT (25.,90.,0)
      CALL GVECT (25.,97.,1)
      CALL GVECT (75.,90.,0)
      CALL GVECT (75.,97.,1)
      CALL GVECT (125.,90.,0)
      CALL GVECT (125.,97.,1)
      CALL GVECT (165.,90.,0)
      CALL GVECT (165.,97.,1)
      CALL GVECT (170.,90.,0)
      CALL GVECT (170.,97.,1)
      CALL GVECT (220.,90.,0)
      CALL GVECT (220.,97.,1)
C
C.....Beschriftung Mitte, Datum und Zeit schreiben
      IF (IOUT .GE. 3) THEN
         CALL GCHAR ('SAND$',45.,93.,2.8)
         CALL GCHAR ('SILT$',95.,93.,2.8)
         CALL GCHAR ('CLAY$',140.,93.,2.8)
         CALL GCHAR ('SILT (100%)$',184.,93.,2.8)
         CALL GCHARA(90)
         CALL GCHAR ('GRAVEL$',21.,78.,2.8)
C
         CALL DATE(TAG)
         CALL GCHARA(90)
         CALL GCHAR ('AWI * SEDAN * '//TAG//'$',223.,15.,1.5)
      END IF
      CALL GCLOSE
      END DO ! Ende der Hauptschleife
      GOTO 660
C..............................................................................
C
C.....+-/* Berechnungen
  670 CONTINUE
      WRITE (6,'(/,A)') ' Berechnungen'
      WRITE (6,'(  A)') ' ************'
      WRITE (6,'(  A)') '$ + - / *           ? -> '
      READ  (5,'(A)') BERE
      WRITE (6,'(/,A)') '$erster  Parameter  ? -> '
      READ  (5,*, ERR=670) IP1
      IF (BERE .EQ. '+') WRITE (6,'(A)')   '         plus '
      IF (BERE .EQ. '-') WRITE (6,'(A)')   '         minus '
      IF (BERE .EQ. '/') WRITE (6,'(A)')   '         geteilt durch '
      IF (BERE .EQ. '*') WRITE (6,'(A)')   '         mal '
      WRITE (6,'(A)')   '$zweiter Parameter  ? (0 f. Konst.) -> '
      READ  (5,*, ERR=670) IP2
      IF (IP2 .EQ. 0) GOTO 672
      IF (KEN(IP1) .NE. KEN(IP2)) THEN
         WRITE (6,'(A)') ' Tiefen stimmen nicht ueberein ! '
         GOTO 670
      END IF
 672  CONTINUE
      WRITE (6,'(/,A)') '$Ergebnis-Parameter ? -> '
      READ  (5,*, ERR=672) IERG
C
C.....berechnen mit einer Konstanten
  674 IF (IP2 .EQ. 0) THEN
         WRITE (6,'(/,A)') '$Konstante ? -> '
         READ  (5,*, ERR=674) RK
         DO I=1,ANTI(KEN(IP1))
         IF (BERE .EQ. '/' .AND. RK .LE. 0.0) THEN
            FELD(IERG,I) = 9999.
            GOTO 673
         END IF
         ZWISCH = FELD(IP1,I)
         IF (BERE .EQ. '+') FELD(IERG,I) = FELD(IP1,I) + RK
         IF (BERE .EQ. '-') FELD(IERG,I) = FELD(IP1,I) - RK
         IF (BERE .EQ. '/') FELD(IERG,I) = FELD(IP1,I) / RK
         IF (BERE .EQ. '*') FELD(IERG,I) = FELD(IP1,I) * RK
         WRITE (6,'(X,F12.3,X,A,3X,F8.2,2X,A,F8.2,A,F8.2)') 
     *   TIEF(KEN(IP1),I), 'm', ZWISCH, BERE, 
     *   RK, ' = ', FELD(IERG,I)
  673    END DO
         GOTO 675
      END IF
C
C.....berechnen mit einem 2. Parameter
      DO I=1,ANTI(KEN(IP1))
         IF (BERE .EQ. '/' .AND. FELD(IP2,I) .LE. 0.0) THEN
            FELD(IERG,I) = 9999.
            GOTO 675           
         END IF
         IF (BERE .EQ. '+') FELD(IERG,I) = FELD(IP1,I) + FELD(IP2,I)
         IF (BERE .EQ. '-') FELD(IERG,I) = FELD(IP1,I) - FELD(IP2,I)
         IF (BERE .EQ. '/') FELD(IERG,I) = FELD(IP1,I) / FELD(IP2,I)
         IF (BERE .EQ. '*') FELD(IERG,I) = FELD(IP1,I) * FELD(IP2,I)
         WRITE (6,'(X,F12.3,X,A,3X,F8.2,2X,A,F8.2,A,F8.2)') 
     *   TIEF(KEN(IP1),I), 'm',FELD(IP1,I), BERE, 
     *   FELD(IP2,I), ' = ', FELD(IERG,I)
  675 END DO
      KEN(IERG) = KEN(IP1)
      WRITE (6, '(/,A,I4)') ' Ergebnis unter Kennung: ', IERG
      CALL RET
      GOTO 600
C..............................................................................
C
C.....Mean, Min, Max - Berechnungen
  680 CONTINUE
      FOUT = KERN(1:4)//'.'//KERN(6:6)//'MMM'
      OPEN (34, FILE=FOUT, STATUS='NEW')
      WRITE (34, '(6X,2A,/)') 'Core: ', KERN
      WRITE (34, '(6X,A9,11X,4A11)')
     *            'Parameter','MIN','MAX','MEAN','STDEV'
      WRITE (34, '(6X,A64)') '---------------------------------------
     *-------------------------'
      WRITE ( 6, '(/,6X,A9,11X,4A11)')
     *            'Parameter','MIN','MAX','MEAN','STDEV'
      WRITE ( 6, '(6X,A64)') '---------------------------------------
     *-------------------------'
C
      DO I = 1,150
         IF (KEN(I) .NE. 0) THEN
            SUMXX = 0.
            SUMX2 = 0.
            IZ = 0
            DO II = 1, ANTI(KEN(I))
               IF (FELD(I,II) .EQ. 9999.) GOTO 682
               IZ = IZ+1
               XA(IZ) = FELD(I,II)
               SUMXX=SUMXX+XA(IZ)
               SUMX2=SUMX2+XA(IZ)*XA(IZ)
  682          CONTINUE
            END DO
            MMFLAG = 1
            CALL MINMAX (IZ,XA,SMIN,SMAX)
C
            VAR=(FLOAT(IZ)*SUMX2-SUMXX*SUMXX)/
     *           FLOAT(IZ*(IZ-1))
            STAB =SQRT(VAR)
            SMEAN=SUMXX/FLOAT(IZ)
C
            WRITE (34,'(X,I4,X,A20,2X,4F10.2)')
     *             I,ENGL(I),SMIN,SMAX,SMEAN,STAB
            WRITE ( 6,'(X,I4,X,A20,2X,4F10.2)')
     *             I,ENGL(I),SMIN,SMAX,SMEAN,STAB
         END IF
      END DO
      WRITE (6,'(/,X,2A)') 'Daten gespeichert in File ', FOUT
      CLOSE (34)
      CALL RET
      GOTO 600
C..............................................................................
C.....Zeit berechnen
C     Tiefen stehen in TIEF(24,I)
C     Anzahl (I) der stratigraphischen Fixpunkte in ANTI(24)
C     Zeiten stehen in FELD(1,I), KEN(1) = 24
C     Sedimentationsraten in FELD(26,I)
C.....stratigraphische Fixpunkte eingeben wenn noch nicht vorhanden
  690 CONTINUE
      TYPE *, CLS
      IF (KEN(1) .EQ. 24) GOTO 696
      KEN(1) = 24
      KPTEXT(24) = 'STRATIGRAPHISCHE FIXPUNKTE'
      WRITE (6,'(/,A)') ' Eingabe der stratigraphischen Fixpunkte'
      WRITE (6,'(A)')   ' ======================================='
      WRITE (6,'(/,A)') '$Anzahl der Fixpunkte => '
      READ  (5,*, ERR=690) ANTI(24)
      DO I = 1, ANTI(24)
  692    WRITE (6,'(/,X,I,A)') I, '. Fixpunkt'
         WRITE (6,'(A)') '$Tiefe (m)  > '
         READ  (5,*, ERR=692) TIEF(24,I)
         IF (I .GT. 1) THEN
         IF (TIEF(24,I) .LE. TIEF(24,I-1)) THEN
            CALL SBELL
            WRITE (6,'(/A)') ' EINGABE-FEHLER !'
            GOTO 692
         END IF
         END IF
  693    WRITE (6,'(A)') '$Alter (ka) > '
         READ  (5,*, ERR=693) FELD(1,I)
         IF (I .GT. 1) THEN
         IF (FELD(1,I) .LE. FELD(1,I-1)) THEN
            CALL SBELL
            WRITE (6,'(/A)') ' EINGABE-FEHLER !'
            GOTO 693
         END IF
         END IF
      END DO
      GOTO 699
C
C.....falls schon Fixpunkte vorhanden, diese korrigieren
  696 CONTINUE
      WRITE (6,'(/,A)') ' Korrektur der stratigraphischen Fixpunkte'
      WRITE (6,'(A)')   ' ========================================='
      WRITE (6,'(A)')   ' <ENTER> fuer OK, 99999 fuer Exit'
      DO I = 1, ANTI(24)
         WRITE (6,'(/,I3,A,F10.3,A,X,F10.3,A)') 
     *       I, '. Fixpunkt:  ', TIEF(24,I), ' m', FELD(1,I), ' ka'
         WRITE (6,'(A)') '$neue Tiefe (m)   > '
         READ  (5,'(A)') CSTRING
         RR = 0.
         CALL PARSV(CSTRING,RR,ZAHL)
         IF (RR .EQ. 99999.) GOTO 699
         IF (ZAHL) TIEF(24,I) = RR
         WRITE (6,'(A)') '$neues Alter (ka) > '
         READ  (5,'(A)') CSTRING
         RR = 0.
         CALL PARSV(CSTRING,RR,ZAHL)
         IF (RR .EQ. 99999.) GOTO 699
         IF (ZAHL) FELD(1,I) = RR
      END DO
  699 CONTINUE
      WRITE (6,'(/A)') '$OK ? [J] > '
      READ  (5, '(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. 'N') GOTO 696
      
C
C.....Alter zwischen den Proben interpolieren
      WRITE (6,'(/,A)') ' Zeit/SedRate wird berechnet fuer die Serien:'
      DO IT = 1, 10
      FELD(26,1) = 0.
      IF (ANTI(IT) .NE. 0) THEN
         WRITE (6,'(X,A)') KPTEXT(IT)
         MT = 1
         DO I = 2, ANTI(24)
            NT = 0
            DS = TIEF(24,I) - TIEF(24,I-1)         ! Dist zwischen 2 Fixpunkten
            DT = FELD(1,I) - FELD(1,I-1)           ! Zeit zwischen 2 Fixpunkten
            QTS = DT/DS                            ! Alter fuer 1 cm
            FELD(26,I) = DS/DT*100.                ! Sedimentationsrate cm/ka
            IF (FELD(26,I) .GT. 500.) FELD(26,I) = 0.
            DO RI = TIEF(24,I-1), TIEF(24,I), 0.01
               IF (NINT(RI*100) .EQ. NINT(TIEF(IT,MT)*100)) THEN
                  TIEF(IT+10,MT) = FELD(1,I-1)+QTS*NT/100.
                  NT = NT+1
                  MT = MT+1
               ELSE 
                  NT = NT+1
               END IF
            END DO
         END DO 
C
C......ev. Alter fuer letzte Probe zuordnen
         ANTI(IT+10) = MT-1
         DO I = 1, ANTI(IT)
           IF (NINT(TIEF(IT,I)*100).EQ.NINT(TIEF(24,ANTI(24))*100))THEN
               TIEF(IT+10,MT) = FELD(1,ANTI(24))
               ANTI(IT+10) = MT
           END IF
           LSTRING = NZEICH(KPTEXT(IT))
           KPTEXT(IT+10) = KPTEXT(IT)(1:LSTRING)//'/ZEIT'
         END DO
      END IF
      END DO
      KEN(26) = KEN(1)
      CALL RET
      GOTO 600
C..............................................................................
C.....CROSPEC-File anlegen
  695 CONTINUE
      TYPE *, CLS
      WRITE (6,'(/A)') ' CROSPEC-File fuer MAC anlegen'
      WRITE (6,'( A)') ' ============================='
      CALL PAR(IKEN)
      IF (ANTI(KEN(IKEN)+10) .EQ. 0) THEN
         WRITE (6,'(/A)') ' keine Zeiten berechnet !'
         CALL RET
         GOTO 600
      END IF
C
      OPEN (12, FILE='AGE.DAT', STATUS='NEW')
      CIN = ENGL(IKEN)
      WRITE (12,'(A,X,A)') 'TIME ', CIN
      DO I = 1, ANTI(KEN(IKEN))
         WRITE (12,'(2F10.4)') TIEF(KEN(IKEN)+10,I), FELD(IKEN,I)
      END DO
      CLOSE (12)
      CALL TIMER(KERN)
      CALL RET
      GOTO 600
C==============================================================================
C-----formatierten Datensatz anlegen
 7001 CALL MIST
  700 CONTINUE
      TYPE *, CLS
      WRITE (6,701)
  701 FORMAT (//,
     *14X,'                    FORMATIEREN'/
     *14X,'                    ==========='/
     *14X,' nur Tiefe oder Zeit .............................<1>'/
     *14X,' beliebiger Datensatz ............................<2>'/
     *14X,' Daten in Serie ..................................<3>'//
     *14X,' Tiefe/Zeit ......................................<4>'/
     *14X,' Sedimentationsraten .............................<5>'/
     *14X,' Sedimentdaten ...................................<6>'//
     *14X,' HAUPTMENUE .................................<Return>')
      WRITE (6,'(/,A)') '$                                    ==> '
      READ (5, '(A)') INCHAR
      IF (INCHAR .EQ. ' ') GOTO 1000
      READ (INCHAR, *) NVAR
C
      IF (NVAR .GT. 3) THEN
         XYZ = 'P'
         GOTO 702
      END IF
      WRITE (6, '(/,A)') '$MAC-Format ? <P>unkt, <K>omma, [N]ein > '
      READ  (5, '(A)')  XYZ
      CALL CAPS (XYZ)
  702 CONTINUE
      IF (NVAR .EQ. 1) GOTO 710
      IF (NVAR .EQ. 4) GOTO 705
      IF (NVAR .EQ. 5) GOTO 750
      IF (NVAR .EQ. 6) GOTO 760
      WRITE (6, '(/,A)') '$<T>iefen/<Z>eit in 1. Spalte ? [N]ein > '
      READ  (5, '(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. ' ') JN = 'N'
C
  705 CONTINUE
      CALL KENT(KPT)
      IF (KPT  .EQ. 0) GOTO 700
      IF (NVAR .EQ. 2) GOTO 720
      IF (NVAR .EQ. 3) GOTO 730
      IF (NVAR .EQ. 4) GOTO 740
      GOTO 700
C
C.....Tiefe oder Zeit formatieren
  710 CONTINUE
      CALL KENT(KPT)
      IF (KPT .EQ. 0) GOTO 700
      FOUT = KERN(1:4)//'.'//KERN(6:6)//'DT'
      IF (XYZ .EQ. 'K' .OR. XYZ .EQ. 'P') 
     *             FOUT='ATK$USER:[GEOLOGIE]'//FOUT
      OPEN (13, FILE=FOUT, CARRIAGECONTROL='LIST', STATUS='NEW')
      DO IT = 1, ANTI(KPT)
         WRITE (13, '(X,F10.3)', ERR=799) TIEF(KPT,IT)
      END DO
      CLOSE (13)
      IF (XYZ .EQ. 'P' .OR. XYZ .EQ. 'K') GOTO 791
      CALL RET
      GOTO 700
C
C.....beliebiger Datensatz
  720 CONTINUE
      WRITE (6,'(/,A)') '$Anzahl der Parameter > '
      READ (5,*,ERR=7001) NVAR
      DO II = 1, NVAR
  721    CONTINUE
         WRITE (6, '(/,X,I3.3,A)') II,'. Parameter '
         CALL PAR (VAROUT(II))
         IF (VAROUT(II) .EQ. 0) GOTO 700
      END DO
      GOTO 780
C
C.....Daten in Serie
  730 CONTINUE
      WRITE (6,'(/,A)') '$erster  Parameter > '
      READ (5,*,ERR=7001) N1
      WRITE (6,'(  A)') '$letzter Parameter > '
      READ (5,*,ERR=7001) NL
      WRITE (6,'(  A)') '$nur vorhandene Parameter ?  [N] > '
      READ (5,'(A)') JJN
      CALL CAPS(JJN)
      NVAR = 0
      KKPT = KPT
      IF (JN .EQ. 'Z') KKPT = KPT-10
      DO II = N1, NL
         IF (JJN .EQ. 'J') THEN
            IF (KEN(II) .EQ. KKPT) THEN
               VAROUT(NVAR+1) = II
               NVAR = NVAR + 1
            END IF
         ELSE
            VAROUT(NVAR+1) = II
            NVAR = NVAR + 1
         END IF
      END DO      
      GOTO 780
C
C.....Tiefe/Zeit-Daten formatieren
  740 CONTINUE
      FOUT = 'ATK$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'DEPTIME'
      OPEN  (13,FILE=FOUT,CARRIAGECONTROL='LIST',STATUS='NEW')
      WRITE (13,'(X,2(A,X))') 'Time', 'Depth'
      DO JJ = 1, ANTI(KPT)
         WRITE (13,'(2F12.3)') TIEF(KPT+10,JJ), TIEF(KPT,JJ)
      END DO
      CLOSE (13)
      GOTO 791      
C
C.....Sedimentationsraten formatieren
  750 CONTINUE
      FOUT = 'ATK$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'SR'
      OPEN  (13,FILE=FOUT,CARRIAGECONTROL='LIST',STATUS='NEW')
      WRITE (13,'(2F12.3)') FELD(1,1), 0.
      WRITE (13,'(2F12.3)') FELD(1,1), FELD(26,2)
      DO JJ = 2, ANTI(24)
         WRITE (13,'(2F12.3)') FELD(1,JJ), FELD(26,JJ)
         WRITE (13,'(2F12.3)') FELD(1,JJ), 0.
         IF (JJ .NE. ANTI(24))
     *       WRITE (13,'(2F12.3)') FELD(1,JJ), FELD(26,JJ+1)
      END DO
      REWIND (13)
C
      FOUT= 'ATK$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'SEDRATE'
      OPEN  (14,FILE=FOUT,CARRIAGECONTROL='LIST',STATUS='NEW')
      WRITE (14,'(X,4(A,X))') 'Time', 'SedRate', 'Time', 'Depth'
      DO JJ = 1, ANTI(24)
         READ (13,*) A, B
         WRITE (14,'(4F12.3)') A, B, FELD(1,JJ), TIEF(24,JJ)
      END DO
  752 CONTINUE
      READ (13,*,END=753) A, B
      WRITE (14,'(2F12.3)') A, B
      GOTO 752
  753 CLOSE (13 , STATUS='DELETE')
      CLOSE (14)
      GOTO 791      
C
C.....Sedimentdaten formatieren
  760 CONTINUE
      FOUT = 'ATK$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'SEDAT'
      OPEN  (13,FILE=FOUT,RECL=200,CARRIAGECONTROL='LIST',STATUS='NEW')
      WRITE (13, '(16A)') 'Depth (m)	','Time (ka)	',
     *'Watercont. (%)	', 'Carbonate (%)	',
     *'organ. Carbon (%)	','IRD	','Sand (%)	',
     *'Silt (%)	','Clay (%)	','Smectite (%)	','Illite (%)	',
     *'Chlorite (%)	','Quarz (%)	','Radiolaria (%)	',
     *'d18O N.pachy	','d13C N.pachy	'
      DO JJ = 1, ANTI(1)
        WRITE(EXCELH,'(16F12.3)') TIEF(1,JJ),  TIEF(11,JJ), 
     * FELD(3,JJ),   FELD(20,JJ), FELD(21,JJ), FELD(30,JJ),
     * FELD(32,JJ),  FELD(33,JJ), FELD(34,JJ), FELD(50,JJ), 
     * FELD(51,JJ),  FELD(52,JJ), FELD(56,JJ), FELD(97,JJ),
     * FELD(123,JJ), FELD(124,JJ)
         CALL MACFORM(EXCELH, MAC, XYZ, IM)
         WRITE (13, '(A)') MAC(:IM)
      END DO
      CLOSE (13)
      GOTO 796
C
C.....MAC-Format erzeugen
 780  CONTINUE
      IF (XYZ .EQ. 'P' .OR. XYZ .EQ. 'K') THEN
         IF (JN .EQ. 'N') IVAR = NVAR
         IF (JN .NE. 'N') IVAR = NVAR + 1
         WRITE (CVAR,'(I3)') IVAR
         FMT = '('//CVAR//'F12.3)'
         IREC = IVAR*12
         GOTO 790
      END IF
C
C.....Format abfragen
      IF (JN .EQ. 'N') WRITE(6,'(/,X,I3.3,A)') NVAR, ' Parameter gesamt'
      IF (JN .NE. 'N') 
     *    WRITE (6,'(/,X,I3.3,A)') NVAR, '  Parameter + Tiefe/Zeit'
      WRITE (6,'(/,A)') '$Format vorgeben  (J/N)  [N] ? '
      READ  (5,'(A)') JNN
      CALL CAPS(JNN)
      IREC = (NVAR+1)*12
      IF (JNN .EQ. 'J') THEN
         WRITE (6,'(A)') '$Format       ==> '
         READ  (5,'(A)') FMT
  782    WRITE (6,'(A)') '$Recordlaenge ==> '
         READ  (5,*, ERR=782) IREC
         GOTO 790
      END IF
C
C.....Format erzeugen
      IF (JN .NE. 'N') NVAR = NVAR + 1
      IF (NVAR .LE. 9) THEN
         WRITE (CVAR,'(I3)') NVAR
         FMT = '('//CVAR//'F8.3)'
      ELSE IF (NVAR .GT. 9 .AND. NVAR .LE. 18) THEN
         NVAR2 = NVAR-9
         WRITE (CVAR,'(I3)') NVAR2
         FMT = '(9F8.3,/,'//CVAR//'F8.3)'
      ELSE IF (NVAR .GT. 18) THEN
         FORM = NVAR/9.
         IFORM = INT(FORM)
         IF (FORM-IFORM .NE. 0) IFORM = IFORM-1
         IF (FORM-IFORM .EQ. 0) IFORM = IFORM-2
         REST = NVAR-(9*(IFORM+1))
         WRITE (CVAR,'(I3)') IFORM
         WRITE (CRES,'(I1)') REST
         FMT ='(9F8.3,/,'//CVAR//'(9F8.3,/),'//CRES//'F8.3)'
      END IF                                                         
      IF (JN .NE. 'N') NVAR = NVAR - 1
C
C-----formatierten multivariaten Datensatz schreiben
  790 CONTINUE
      WRITE (6, '(/,X,2A)') 'Format der Datenmatrix: ', FMT
      WRITE (6, '(/,A)') '$Parameterbez. in die 1. Zeile ?  [N] > '
      READ  (5,'(A)') JNN
      CALL CAPS(JNN)
      WRITE (6, '(/,A)') '$Pfad/Name des Ausgabefiles ? [xxxx.xDAT] > '
      READ  (5, '(A)')   FOUT
      IF (FOUT .EQ. ' ') FOUT = KERN(1:4)//'.'//KERN(6:6)//'DAT'
      OPEN  (13, FILE=FOUT, RECL=IREC, 
     *           CARRIAGECONTROL='LIST', STATUS='NEW')
C
      IF (JNN .EQ. 'J') THEN
         FMT1 = '('//CVAR//'(A4,X))'
         IF (JN .NE. 'N') THEN
CCC            WRITE (13, FMT1, ERR=799) 
CCC     *      'Depth   ', (ENGL(VAROUT(J)), J=1,NVAR)
            WRITE (13, FMT, ERR=799) .0, (FLOAT(VAROUT(J)), J=1,NVAR)
         ELSE
CCC            WRITE (13, FMT1, ERR=799)
CCC     *                  (ENGL(VAROUT(J)), J=1,NVAR)
            WRITE (13, FMT, ERR=799)     (FLOAT(VAROUT(J)), J=1,NVAR)
         END IF
      END IF
C
      DO I = 1, ANTI(KPT)
         IF (JN .NE. 'N') THEN
            WRITE (13, FMT, ERR=799)
     *                  TIEF(KPT,I), (FELD(VAROUT(J),I), J=1,NVAR)
         ELSE 
            WRITE (13, FMT, ERR=799) (FELD(VAROUT(J),I), J=1,NVAR)
         END IF
      END DO
      CLOSE (13)
      IF (XYZ .EQ. ' ' .OR. XYZ .EQ. 'N') GOTO 700
C
C.....MAC-Format schreiben
  791 CONTINUE
      OPEN (13, FILE=FOUT, STATUS ='OLD')
      OPEN (14, FILE=FOUT, RECL=IREC,
     *              CARRIAGECONTROL='LIST', STATUS='NEW')
      EXCELH = ' '
      MAC    = ' '
  792 CONTINUE
      READ (13,'(A)', END = 795) EXCELH
C
C.....Leerzeichen durch TAB ersetzen
      ITAB = 1
      IMAC = 0
      LSTRING = NZEICH(EXCELH)
      DO I = 1, LSTRING
         IF (EXCELH(I:I) .EQ. ' ') THEN
            IF (ITAB .EQ. 0) THEN
               IMAC = IMAC + 1
               MAC(IMAC:IMAC) = '	'
               ITAB = 1
            END IF
         ELSE
            IMAC = IMAC + 1
            MAC (IMAC:IMAC) = EXCELH(I:I)
C
C.....Punkte durch Komma ersetzen
            IF (XYZ .EQ. 'K') THEN
               IF (MAC(IMAC:IMAC) .EQ. '.') MAC(IMAC:IMAC) = ','
            END IF
            ITAB = 0
         END IF
      END DO
      WRITE (14,'(A)') MAC(:IMAC)
      GOTO 792
C
  795 CONTINUE
      CLOSE (13, STATUS='DELETE')
      CLOSE (14)
  796 CONTINUE
      WRITE (6,'(/,2A)') ' Daten stehen in ', FOUT
      CALL RET
      GOTO 700
C==============================================================================
C-----Fehlermeldungen
  799 WRITE (6, '(/,A)') ' ======================================'
      WRITE (6, '(A)')   ' * !!!  F O R M A T    E R R O R  !!! *'
      WRITE (6, '(A)')   ' ======================================'
      CALL RET
      GOTO 700
C==============================================================================
  999 CONTINUE
      WRITE (6, '(/,A)') ' =============================='
      WRITE (6, '(A)')   ' * !!!  FILE  NOT  FOUND  !!! *'
      WRITE (6, '(A)')   ' =============================='
      CALL RET
      GOTO 1000
C==============================================================================
C-----Feld speichern
 1234 CONTINUE
      OPEN (77, FILE=FILNAM, STATUS='NEW', ERR=4322, FORM='UNFORMATTED')
C
C..Tiefen......................................................................
      DO I=1,NTIEF
         IF (ANTI(I) .EQ. 0) THEN
            WRITE (77) ANTI(I)
         ELSE
            WRITE (77) ANTI(I), (TIEF(I,K), K=1,ANTI(I))
            WRITE (77) KPTEXT(I)
         END IF
      END DO
C
C..Sonderparameter.............................................................
      WRITE (77) SUMIRD
      WRITE (77) TOP, BOT, ANZGR
C
C..Daten.......................................................................
      DO 9876 I=1,NPAR
         IF (KEN(I) .NE. 0) 
     *      WRITE (77) KEN(I), I, (FELD(I,K), K=1,ANTI(KEN(I)))
 9876 CONTINUE
C
C..Ende.......................................................................
      CLOSE (77)
      GOTO 4321 
 4322 CONTINUE
      TYPE *, CLS
      WRITE(6,'(22X,A/)')' Daten werden nicht gespeichert !'
      GOTO 4323
 4321 TYPE *, CLS
 4323 CALL DATE(TAG)
      CALL TIME(ZEIT)
      IF (KERN(5:5) .NE. '-') THEN
         WRITE (6,'(7X,7A)') '*** ', KERN, 
     *      '*** SEDAN  Ende *** ', TAG, ' *** ', ZEIT, ' Uhr ***'
      ELSE
         WRITE (6,'(7X,7A)') '*** Kern ', KERN, 
     *      ' *** SEDAN  Ende *** ', TAG, ' *** ', ZEIT, ' Uhr ***'
      END IF
54321 END